// Called when capture operation is finished
//
function captureSuccess(mediaFiles) {
    var i, len;

    for (i = 0, len = mediaFiles.length; i < len; i += 1) {
        console.log("bbbbb" + mediaFiles[i])
        onVideoURISuccess(mediaFiles[i]);
    }       
}

// Called when capture operation is finished
//
function captureaudioSuccess(mediaFiles) {
    var i, len;

    for (i = 0, len = mediaFiles.length; i < len; i += 1) {
        onAudioURISuccess(mediaFiles[i]);
    }       
}

// Called if something bad happens.
// 
function captureError(error) {
    var msg = 'An error occurred during capture: ' + error.code;
    // navigator.notification.alert(msg, null, 'Error!');
}

// Called if something bad happens.
// 
function captureaudioError(error) {
    var msg = 'An error occurred during capture: ' + error.code;
    // navigator.notification.alert(msg, null, 'Error!');
}

// Called when a Video is successfully retrieved
//
function onVideoURISuccess(videofile) {
    var sender_id = $('#sendMessageButton').attr('data-sender-id');
    var message_client_id = (sender_id+'_'+($.now()));
    console.log("aaaa" + videofile.fullPath);
    $('#msgReader').append( // sender append chat message
        '<div  class="fRight mLeft8 chatRight" id="'+ message_client_id +'"><span class="chatRightArrow"><img src="img/chat-right.gif" alt="" /></span><img src="img/play.png" onclick="openVideo('+ "'" + videofile.fullPath + "'" +')" width="30" style="position:absolute;left: 42px;top:26px;"/><img class="attachment-image-message" style="height:65px;width=100px" width="100" height="65" onclick="openVideo('+ "'" + videofile.fullPath + "'" +')"  src="img/video-icon.png" /><p class="date"><span><img src="img/schedule-clock.png" width="9"/></span></p></div><div class="clear"></div>'
    );
    // 
    // hide chat options
    hideOptionsP2p(); 
    // scroll top slowly
    $('#msgReader').animate({ scrollTop: $('#msgReader').get(0).scrollHeight }, 1500);

    // Upload the image to server using FileTransfer
    // 
    var options = new FileUploadOptions();
    options.fileKey     = "file";
    options.fileName    = videofile.name
    options.mimeType = "video/mp4";
    options.headers = {
        Connection: "close"
    }
    options.chunkedMode = false;
    var ft = new FileTransfer();
    ft.upload(
        videofile.fullPath, 
        encodeURI($.apiUrl + "/ccc/file_upload"), 
        function(r) {
            var video_url = r.response.replace(/[\n]/g, "");
            uploadVideo(video_url, message_client_id);
        },
        function(error) {
            // alert("An error has occurred: Code = " + error.code);
            // console.log("upload error source " + error.source);
            // console.log("upload error target " + error.target);
            alert("An error has occurred");
            //$('#'+message_client_id).remove();
        }, 
        options
    );

}

// Called when a Audio is successfully retrieved
//
function onAudioURISuccess(audiofile) {
    var sender_id = $('#sendMessageButton').attr('data-sender-id');
    var message_client_id = (sender_id+'_'+($.now()));
    console.log("aaaa" + audiofile.fullPath);
    $('#msgReader').append(
        '<div  class="fRight mLeft8 chatRight" id="'+ message_client_id +'"><span class="chatRightArrow"><img src="img/chat-right.gif" alt="" /></span><img class="attachment-image-message positioncenter"  onclick="openAudio(' + "'" + audiofile.fullPath + "'" + ')"  style="width: 32px; height: 32px;" src="img/audio-icon.gif" /><p class="date"><span><img src="img/schedule-clock.png" width="9"/></span></p></div><div class="clear"></div>'
    );
    // 
    // hide chat options
    hideOptionsP2p();    
    // scroll top slowly
    $('#msgReader').animate({ scrollTop: $('#msgReader').get(0).scrollHeight }, 1500);

    // Upload the image to server using FileTransfer
    // 
    var options = new FileUploadOptions();
    options.fileKey     = "file";
    options.fileName    = audiofile.name
    options.mimeType = "audio/mp3";
    options.headers = {
        Connection: "close"
    }
    options.chunkedMode = false;
    var ft = new FileTransfer();
    ft.upload(
        audiofile.fullPath, 
        encodeURI($.apiUrl + "/ccc/file_upload"), 
        function(r) {
            var audio_url = r.response.replace(/[\n]/g, "");
            uploadAudio(audio_url, message_client_id);
        },
        function(error) {
            // alert("An error has occurred: Code = " + error.code);
            // console.log("upload error source " + error.source);
            // console.log("upload error target " + error.target);
            alert("An error has occurred");
            //$('#'+message_client_id).remove();
        }, 
        options
    );

}

// Called when a photo is successfully retrieved
//
function onPhotoURISuccess(imageURI) {
    var sender_id = $('#sendMessageButton').attr('data-sender-id');
    var message_client_id = (sender_id+'_'+($.now()));

    $('#msgReader').append( // sender append chat message
        '<div  class="fRight mLeft8 chatRight" id="'+ message_client_id +'"><span class="chatRightArrow"><img src="img/chat-right.gif" alt="" /></span><img class="attachment-image-message" style="height:30%" onclick="openImage('+  "'" + imageURI.toString() + "'" +')"  src="'+imageURI+'" /><p class="date"><span><img src="img/schedule-clock.png" width="9"/></span></p></div><div class="clear"></div>'
    );
    // 
    // hide chat options
    hideOptionsP2p();    
    // scroll top slowly
     $('#msgReader').animate({ scrollTop: $('#msgReader').get(0).scrollHeight }, 1500);
    // Upload the image to server using FileTransfer
    // 
    var options = new FileUploadOptions();
    options.fileKey     = "file";
    options.fileName    = imageURI.substr(imageURI.lastIndexOf('/')+1);
    options.mimeType    = "image/jpeg";
    options.headers = {
        Connection: "close"
    }
    options.chunkedMode = false;
    var ft = new FileTransfer();
    ft.upload(
        imageURI, 
        encodeURI($.apiUrl + "/ccc/file_upload"), 
        function(r) {
            var image_url = r.response.replace(/[\n]/g, "");
            uploadPhoto(image_url, message_client_id);
        },
        function(error) {
            // alert("An error has occurred: Code = " + error.code);
            // console.log("upload error source " + error.source);
            // console.log("upload error target " + error.target);
            alert("An error has occurred");
            //$('#'+message_client_id).remove();
        }, 
        options
    );

}


// Called when a galary video is successfully retrieved
//
function ongallaryVideoURISuccess(videoURI) {
    var sender_id = $('#sendMessageButton').attr('data-sender-id');
    var message_client_id = (sender_id+'_'+($.now()));

    $('#msgReader').append( // sender append chat message
        '<div  class="fRight mLeft8 chatRight" id="'+ message_client_id +'"><span class="chatRightArrow"><img src="img/chat-right.gif" alt="" /></span><img src="img/play.png" onclick="openVideo('+ "'" + videoURI.toString() + "'" +')"   width="30" style="position:absolute;left:42px;top:26px;"/><img class="attachment-image-message" style="height:65px;width=100px" width="100" height="65" onclick="openVideo('+ "'" + videoURI.toString() + "'" +')" src="img/video-icon.png" /><p class="date"><span><img src="img/schedule-clock.png" width="9"/></span></p></div><div class="clear"></div>'
    );
    // 
    // hide chat options
    hideOptionsP2p();
    // scroll top slowly
    $('#msgReader').animate({ scrollTop: $('#msgReader').get(0).scrollHeight }, 1500);

    // Upload the video to server using FileTransfer
    // 
    var options = new FileUploadOptions();
    options.fileKey     = "file";
    options.fileName    = videoURI.substr(videoURI.lastIndexOf('/')+1);
    options.mimeType    = "video/mp4";
    options.headers = {
        Connection: "close"
    }
    options.chunkedMode = false;
    var ft = new FileTransfer();
    ft.upload(
        videoURI, 
        encodeURI($.apiUrl + "/ccc/file_upload"), 
        function(r) {
            var video_url = r.response.replace(/[\n]/g, "");
            uploadVideo(video_url, message_client_id);
        },
        function(error) {
            // alert("An error has occurred: Code = " + error.code);
            // console.log("upload error source " + error.source);
            // console.log("upload error target " + error.target);
            alert("An error has occurred");
            //$('#'+message_client_id).remove();
        }, 
        options
    );

}



// Called when a galary file is successfully retrieved
//
function ongallaryFileURISuccess(fileURI) {
    var sender_id = $('#sendMessageButton').attr('data-sender-id');
    var message_client_id = (sender_id+'_'+($.now()));

    $('#msgReader').append( // sender append chat message
        '<div onclick="openFile('+ "'" + fileURI.toString() + "'" +')" class="fRight mLeft8 chatRight" id="'+ message_client_id +'"><span class="chatRightArrow"><img src="img/chat-right.gif" alt="" /></span><img class="attachment-image-message positioncenter" style="height: 32px; width: 32px;" src="img/file-icon.png" /><p class="date"><span><img src="img/schedule-clock.png" width="9"/></span></p></div><div class="clear"></div>'
    );
    // 
    // hide chat options
    hideOptionsP2p();
    // scroll top slowly
    $('#msgReader').animate({ scrollTop: $('#msgReader').get(0).scrollHeight }, 1500);

    // Upload the video to server using FileTransfer
    // 
    var options = new FileUploadOptions();
    options.fileKey     = "file";
    options.fileName    = fileURI.substr(fileURI.lastIndexOf('/')+1);
    options.mimeType    = "";
    options.headers = {
        Connection: "close"
    }
    options.chunkedMode = false;
    var ft = new FileTransfer();
    ft.upload(
        fileURI, 
        encodeURI($.apiUrl + "/ccc/file_upload"), 
        function(r) {
            var file_url = r.response.replace(/[\n]/g, "");
            uploadFile(file_url, message_client_id);
        },
        function(error) {
            // alert("An error has occurred: Code = " + error.code);
            // console.log("upload error source " + error.source);
            // console.log("upload error target " + error.target);
            alert("An error has occurred");
            //$('#'+message_client_id).remove();
        }, 
        options
    );

}

// Finally upload it to the server.
// 
function uploadPhoto(image_url, message_client_id) {
    var session_token = localStorage["session_token"]
    var channel_name = $('#sendMessageButton').attr('data-channel-name');
    var receiver_id = $('#sendMessageButton').attr('data-receiver-id');   
    console.log(image_url)
    console.log(receiver_id)  
    console.log(channel_name)
    console.log(message_client_id)    
    $.ajax({
        url: $.apiUrl + "/ccc/api_v1/message_attachment",
        type: "POST",
        data: {
            attachment: image_url,
            attachment_type: 'image',
            recipient_id: receiver_id,
            channel_name: channel_name,
            channel_event: 'attachment-message',
            message_client_id: message_client_id
        },
        beforeSend: function(xhr) { 
            xhr.setRequestHeader('token', session_token);
        },
        success: function(json){ },
        error: function (xhr, ajaxOptions, thrownError) {
            alert(xhr.status);
            alert(thrownError);
            //$('#'+message_client_id).remove();
        }
    });
}

// Finally upload it to the server.
// 
function uploadVideo(video_url, message_client_id) {
    var session_token = localStorage["session_token"]
    var channel_name = $('#sendMessageButton').attr('data-channel-name');
    var receiver_id = $('#sendMessageButton').attr('data-receiver-id');   
      
    $.ajax({
        url: $.apiUrl + "/ccc/api_v1/message_attachment",
        type: "POST",
        data: {
            attachment: video_url,
            attachment_type: 'video',
            recipient_id: receiver_id,
            channel_name: channel_name,
            channel_event: 'attachment-message',
            message_client_id: message_client_id
        },
        beforeSend: function(xhr) { 
            xhr.setRequestHeader('token', session_token);
        },
        success: function(json){ },
        error: function (xhr, ajaxOptions, thrownError) {
            alert(xhr.status);
            alert(thrownError);
            //$('#'+message_client_id).remove();
        }
    });
}

// Finally upload it to the server.
// 
function uploadFile(file_url, message_client_id) {
    var session_token = localStorage["session_token"]
    var channel_name = $('#sendMessageButton').attr('data-channel-name');
    var receiver_id = $('#sendMessageButton').attr('data-receiver-id');   
      
    $.ajax({
        url: $.apiUrl + "/ccc/api_v1/message_attachment",
        type: "POST",
        data: {
            attachment: file_url,
            attachment_type: 'file',
            recipient_id: receiver_id,
            channel_name: channel_name,
            channel_event: 'attachment-message',
            message_client_id: message_client_id
        },
        beforeSend: function(xhr) { 
            xhr.setRequestHeader('token', session_token);
        },
        success: function(json){ },
        error: function (xhr, ajaxOptions, thrownError) {
            alert(xhr.status);
            alert(thrownError);
            //$('#'+message_client_id).remove();
        }
    });
}

// Finally upload it to the server.
// 
function uploadAudio(audio_url, message_client_id) {
    var session_token = localStorage["session_token"]
    var channel_name = $('#sendMessageButton').attr('data-channel-name');
    var receiver_id = $('#sendMessageButton').attr('data-receiver-id');   
      
    $.ajax({
        url: $.apiUrl + "/ccc/api_v1/message_attachment",
        type: "POST",
        data: {
            attachment: audio_url,
            attachment_type: 'audio',
            recipient_id: receiver_id,
            channel_name: channel_name,
            channel_event: 'attachment-message',
            message_client_id: message_client_id
        },
        beforeSend: function(xhr) { 
            xhr.setRequestHeader('token', session_token);
        },
        success: function(json){ },
        error: function (xhr, ajaxOptions, thrownError) {
            alert(xhr.status);
            alert(thrownError);
            //$('#'+message_client_id).remove();
        }
    });
}

// Called if something bad happens.
//
function onFail(message) {
    alert('Failed because: ' + message);
}

// A button will call this function
//
function capturePhoto() {
            var options = {
                title : "Select image file...",
                types : window.imagetypes,
                typesDescription : "Image files",
                path : "/"
            };

            var curwin = Ti.UI.currentWindow; 
            curwin.openFileChooserDialog( function(fileResponse) { 
                var file = Ti.Filesystem.getFile(fileResponse[0]); 
                desktopUploadImage(file);
            },options);
            hideOptionsP2p(); 

}

var desktopUploadImage = function(file){
            console.log("FILE");
            console.log(file);
            
            var uploadStream = Ti.Filesystem.getFileStream(file);
        
            uploadStream.open(Ti.Filesystem.MODE_READ);
            content = uploadStream.read();
            uploadStream.close();
            
            var sender_id = $('#sendMessageButton').attr('data-sender-id');
            var channel_name = $('#sendMessageButton').attr('data-channel-name');
            var receiver_id = $('#sendMessageButton').attr('data-receiver-id');
            var message_client_id = (sender_id+'_'+($.now()));
            local_file = "file:///" + file.toString();
            $('#msgReader').append( // sender append chat message
                '<div  class="fRight mLeft8 chatRight" id="'+ message_client_id +'"><span class="chatRightArrow"><img src="img/chat-right.gif" alt="" /></span><img class="attachment-image-message" style="height:30%" onclick="openImage('+  "'" + local_file + "'" +')"  src="'+local_file+'" /><p class="date"><span><img src="img/schedule-clock.png" width="9"/></span></p></div><div class="clear"></div>'
            );
            hideOptionsP2p();    
            // scroll top slowly
            $('#msgReader').animate({ scrollTop: $('#msgReader').get(0).scrollHeight }, 1500);


            //save locally

            current_msg_obj = {
                                "sender": {
                                    "id": sender_id,
                                    "name": '',
                                    "photo": ''
                                },
                                "receiver": {
                                    "id": receiver_id,
                                    "name": '',
                                    "photo": ''
                                },
                                "message_id": $.now(),
                                "channel_name": channel_name,
                                "message": '',
                                "date": '',
                                "message_client_id": message_client_id,
                                "time": '',
                                "merge_to_last_message": 'false',
                                "textformat": '',
                                "attachment_type": 'image',
                                "attachment_url": local_file,
                                "channel_event": "message",
                                "video_image": '',
                                "allowed_suborg_ids": ''
                }
                saveMessageToDB(current_msg_obj);

            var xhr = Ti.Network.createHTTPClient();
            xhr.addEventListener(Ti.HTTP_DONE, function(){
                //alert('done');
                console.log("TI XHR DONE!");
                console.log(this.responseText);
                uploadPhoto(this.responseText, message_client_id);
                //text.innerHTML += "\n" + this.responseText;
            });
            xhr.addEventListener(Ti.HTTP_STATE_CHANGED, function(){
                //alert('changed');
                console.log("STATE CHANGED");
                console.log(this.responseText);
                //text.innerHTML += "\n" + this.responseText;
            });
            
            xhr.open('POST', $.apiUrl + "/ccc/desktp_file_upload");
            xhr.setRequestHeader("contentType", "multipart/form-data");
            xhr.send({uploadedfile: content,file: file});
}

// A button will call this function
//
function getPhoto() {
    // Retrieve image file location from specified source
    // navigator.camera.getPicture(onPhotoURISuccess, onFail, 
    //     { 
    //         quality: 50, 
    //         destinationType: navigator.camera.DestinationType.FILE_URL,
    //         sourceType: navigator.camera.PictureSourceType.PHOTOLIBRARY 
    //     }
    // );
}

//audio capture
function captureAudio(){
    // Launch device audio recording application, 
    // allowing user to capture up to 1 audio clips
   // navigator.device.capture.captureAudio(captureaudioSuccess, captureaudioError, {limit: 1});
   var options = {
                title : "Select audio file...",
                types : window.soundtypes,
                typesDescription : "Sound clips",
                path : "/"
            };

    var curwin = Ti.UI.currentWindow; 
    curwin.openFileChooserDialog( function(fileResponse) { 
        var file = Ti.Filesystem.getFile(fileResponse[0]); 
        desktopUploadAudio(file);
    },options);
    hideOptionsP2p(); 

}

var desktopUploadAudio = function(file){
            console.log("FILE");
            console.log(file);
            
            var uploadStream = Ti.Filesystem.getFileStream(file);
        
            uploadStream.open(Ti.Filesystem.MODE_READ);
            content = uploadStream.read();
            uploadStream.close();
        
            console.log("CONTENT");
            console.log(content);
            var sender_id = $('#sendMessageButton').attr('data-sender-id');
            var channel_name = $('#sendMessageButton').attr('data-channel-name');
            var receiver_id = $('#sendMessageButton').attr('data-receiver-id');  
            var message_client_id = (sender_id+'_'+($.now()));
            local_file = "file:///" + file.toString();
            $('#msgReader').append(
                '<div  class="fRight mLeft8 chatRight" id="'+ message_client_id +'"><span class="chatRightArrow"><img src="img/chat-right.gif" alt="" /></span><img class="attachment-image-message positioncenter"  onclick="openAudio(' + "'" + local_file + "'" + ')"  style="width: 32px; height: 32px;" src="img/audio-icon.gif" /><p class="date"><span><img src="img/schedule-clock.png" width="9"/></span></p></div><div class="clear"></div>'
            );
            // 
            // hide chat options
            hideOptionsP2p();    
            // scroll top slowly
            $('#msgReader').animate({ scrollTop: $('#msgReader').get(0).scrollHeight }, 1500);

            current_msg_obj = {
                    "sender": {
                        "id": sender_id,
                        "name": '',
                        "photo": ''
                    },
                    "receiver": {
                        "id": receiver_id,
                        "name": '',
                        "photo": ''
                    },
                    "message_id": $.now(),
                    "channel_name": channel_name,
                    "message": '',
                    "date": '',
                    "message_client_id": message_client_id,
                    "time": '',
                    "merge_to_last_message": 'false',
                    "textformat": '',
                    "attachment_type": 'audio',
                    "attachment_url": local_file,
                    "channel_event": "message",
                    "video_image": '',
                    "allowed_suborg_ids": ''
            }
            saveMessageToDB(current_msg_obj);

            var xhr = Ti.Network.createHTTPClient();
            xhr.addEventListener(Ti.HTTP_DONE, function(){
                //alert('done');
                console.log("TI XHR DONE!");
                console.log(this.responseText);
                uploadAudio(this.responseText, message_client_id);
                //text.innerHTML += "\n" + this.responseText;
            });
            xhr.addEventListener(Ti.HTTP_STATE_CHANGED, function(){
                //alert('changed');
                console.log("STATE CHANGED");
                console.log(this.responseText);
                //text.innerHTML += "\n" + this.responseText;
            });
            
            xhr.open('POST', $.apiUrl + "/ccc/desktp_file_upload");
            xhr.setRequestHeader("contentType", "multipart/form-data");
            xhr.send({uploadedfile: content,file: file});
}

//Video capture
function captureVideo() {
        // Launch device video recording application, 
        // allowing user to capture up to 1 video clips
        // navigator.device.capture.captureVideo(captureSuccess, captureError, {limit: 1});
}

// A button will call this function
//
function getVideo() {
        //get video from library
        /*navigator.camera.getPicture(ongallaryVideoURISuccess, onFail, 
        { 
            quality: 50, 
            destinationType: navigator.camera.DestinationType.FILE_URL,
            sourceType: navigator.camera.PictureSourceType.PHOTOLIBRARY,
            mediaType: navigator.camera.MediaType.VIDEO 
        }
    );*/
    var options = {
                title : "Select video file...",
                types : window.videotypes,
                typesDescription : "Video files",
                path : "/"
            };

            var curwin = Ti.UI.currentWindow; 
            curwin.openFileChooserDialog( function(fileResponse) { 
                var file = Ti.Filesystem.getFile(fileResponse[0]); 
                desktopUploadVideo(file);
            },options);
            hideOptionsP2p(); 
}

var desktopUploadVideo = function(file){
            console.log("FILE");
            console.log(file);
            
            var uploadStream = Ti.Filesystem.getFileStream(file);
        
            uploadStream.open(Ti.Filesystem.MODE_READ);
            content = uploadStream.read();
            uploadStream.close();
        
            console.log("CONTENT");
            console.log(content);
            var sender_id = $('#sendMessageButton').attr('data-sender-id');
            var channel_name = $('#sendMessageButton').attr('data-channel-name');
            var receiver_id = $('#sendMessageButton').attr('data-receiver-id');   
            var message_client_id = (sender_id+'_'+($.now()));
            local_file = "file:///" + file.toString();
            $('#msgReader').append( // sender append chat message
                '<div  class="fRight mLeft8 chatRight" id="'+ message_client_id +'"><span class="chatRightArrow"><img src="img/chat-right.gif" alt="" /></span><img src="img/play.png" onclick="openVideo('+ "'" + local_file + "'" +')" width="30" style="position:absolute;left: 42px;top:26px;"/><img class="attachment-image-message" style="height:65px;width=100px" width="100" height="65" onclick="openVideo('+ "'" + local_file + "'" +')"  src="img/video-icon.png" /><p class="date"><span><img src="img/schedule-clock.png" width="9"/></span></p></div><div class="clear"></div>'
            );
            // 
            // hide chat options
            hideOptionsP2p(); 
            // scroll top slowly
            $('#msgReader').animate({ scrollTop: $('#msgReader').get(0).scrollHeight }, 1500);


            current_msg_obj = {
                    "sender": {
                        "id": sender_id,
                        "name": '',
                        "photo": ''
                    },
                    "receiver": {
                        "id": receiver_id,
                        "name": '',
                        "photo": ''
                    },
                    "message_id": $.now(),
                    "channel_name": channel_name,
                    "message": '',
                    "date": '',
                    "message_client_id": message_client_id,
                    "time": '',
                    "merge_to_last_message": 'false',
                    "textformat": '',
                    "attachment_type": 'video',
                    "attachment_url": local_file,
                    "channel_event": "message",
                    "video_image": 'img/video-icon.png',
                    "allowed_suborg_ids": ''
            }
            saveMessageToDB(current_msg_obj);

            var xhr = Ti.Network.createHTTPClient();
            xhr.addEventListener(Ti.HTTP_DONE, function(){
                //alert('done');
                console.log("TI XHR DONE!");
                console.log(this.responseText);
                uploadVideo(this.responseText, message_client_id);
                //text.innerHTML += "\n" + this.responseText;
            });
            xhr.addEventListener(Ti.HTTP_STATE_CHANGED, function(){
                //alert('changed');
                console.log("STATE CHANGED");
                console.log(this.responseText);
                //text.innerHTML += "\n" + this.responseText;
            });
            
            xhr.open('POST', $.apiUrl + "/ccc/desktp_file_upload");
            xhr.setRequestHeader("contentType", "multipart/form-data");
            xhr.send({uploadedfile: content,file: file});
}

function getFile() {
        //get video from library
        /*navigator.camera.getPicture(ongallaryFileURISuccess, onFail, 
        { 
            quality: 50, 
            destinationType: navigator.camera.DestinationType.FILE_URL,
            sourceType: navigator.camera.PictureSourceType.PHOTOLIBRARY,
            mediaType: navigator.camera.MediaType.ALLMEDIA 
        }
    );*/
    var options = {
                title : "Select  file...",
                types : window.filetypes,
                typesDescription : "Files ",
                path : "/"
            };

    var curwin = Ti.UI.currentWindow; 
    curwin.openFileChooserDialog( function(fileResponse) { 
        var file = Ti.Filesystem.getFile(fileResponse[0]); 
        desktopUploadFile(file);
    },options);
    hideOptionsP2p();
}

var desktopUploadFile = function(file){
            console.log("FILE");
            console.log(file);
            
            var uploadStream = Ti.Filesystem.getFileStream(file);
        
            uploadStream.open(Ti.Filesystem.MODE_READ);
            content = uploadStream.read();
            uploadStream.close();
        
            console.log("CONTENT");
            console.log(content);
            var sender_id = $('#sendMessageButton').attr('data-sender-id');
            var channel_name = $('#sendMessageButton').attr('data-channel-name');
            var receiver_id = $('#sendMessageButton').attr('data-receiver-id');
            var message_client_id = (sender_id+'_'+($.now()));
            local_file = "file:///" + file.toString();
            $('#msgReader').append( // sender append chat message
                '<div class="fRight mLeft8 chatRight" id="'+ message_client_id +'"><span class="chatRightArrow"><img src="img/chat-right.gif" alt="" /></span><img onclick="openremoteFile('+ "'" + local_file + "'" +')" class="attachment-image-message positioncenter" style="height: 32px; width: 32px;" src="img/file-icon.png" /><p class="date"><span><img src="img/schedule-clock.png" width="9"/></span></p></div><div class="clear"></div>'
            );
            // 
            // hide chat options
            hideOptionsP2p();
            // scroll top slowly
            $('#msgReader').animate({ scrollTop: $('#msgReader').get(0).scrollHeight }, 1500);


            current_msg_obj = {
                    "sender": {
                        "id": sender_id,
                        "name": '',
                        "photo": ''
                    },
                    "receiver": {
                        "id": receiver_id,
                        "name": '',
                        "photo": ''
                    },
                    "message_id": $.now(),
                    "channel_name": channel_name,
                    "message": '',
                    "date": '',
                    "message_client_id": message_client_id,
                    "time": '',
                    "merge_to_last_message": 'false',
                    "textformat": '',
                    "attachment_type": 'file',
                    "attachment_url": local_file,
                    "channel_event": "message",
                    "video_image": '',
                    "allowed_suborg_ids": ''
            }
            saveMessageToDB(current_msg_obj);
            var xhr = Ti.Network.createHTTPClient();
            xhr.addEventListener(Ti.HTTP_DONE, function(){
                //alert('done');
                console.log("TI XHR DONE!");
                console.log(this.responseText);
                uploadFile(this.responseText, message_client_id);
                //text.innerHTML += "\n" + this.responseText;
            });
            xhr.addEventListener(Ti.HTTP_STATE_CHANGED, function(){
                //alert('changed');
                console.log("STATE CHANGED");
                console.log(this.responseText);
                //text.innerHTML += "\n" + this.responseText;
            });
            
            xhr.open('POST', $.apiUrl + "/ccc/desktp_file_upload");
            xhr.setRequestHeader("contentType", "multipart/form-data");
            xhr.send({uploadedfile: content,file: file});
}

