$().ready(function(){
	var userinfo 		= $.parseJSON(localStorage["userinfo"]);
	var groups 			= $.parseJSON(localStorage["hris_enterprise_chat_groups"]);
	var current_user_id = userinfo.user_info.user_id

	// subscription to group channels
	var pubnub = PUBNUB.init({
	    publish_key: $.pubnubkeys.publish_key,
        subscribe_key: $.pubnubkeys.subscribe_key
	});    

	$.each(groups, function(i, group) {
		var channel_name = group.group_id + '_group_channel';
		pubnub.subscribe({
		    channel: channel_name,
		    message: function (m) {
		    	var message_obj = $.parseJSON(m);
		    	var date;
		    	var datetime;
		    	console.log(m);
                datetime = datify(message_obj);
                // append/save/cache to history
                        if(typeof(message_obj.message) != "undefined"){
                            if(message_obj.message.is_liking == "1"){
                                updatelikestatus(message_obj)
                            }else{
                            	saveMessageToDB(message_obj)
                            }
                        }else{
                        	saveMessageToDB(message_obj)
                        }
                

	            if ($("#groupMsgReader[data-channel-name='" + channel_name + "']:visible").length > 0) { // if role/group chat window is open
	            	if(message_obj.message){
		            	if(message_obj.message.is_liking == "1"){
		            		if(message_obj.message.like_count.toString() == "0"){
		            			$("#"+ message_obj.message.id).next().text("");
		            		}else{
		            			$("#"+ message_obj.message.id).next().text(" + " +message_obj.message.like_count);	
		            		}
		            		
		            	}
	            	}
	            	if(message_obj.sender){
	                if (message_obj.sender.id == current_user_id){
	                	console.log("here");
	                	
						if(message_obj.is_liking == "0"){
							$("#"+ message_obj.message_client_id +" .date").html('<span>'+ datetime +'</span>');
							$("#"+ message_obj.message_client_id +" .date").addClass('pRelative');
							$("#"+ message_obj.message_client_id +" .date").append(likeGroupRight(message_obj,channel_name,"img/like-icon-grey-rev.png"));
							$("#" + message_obj.message_client_id + " .attachment-image-message").attr('src',message_obj.video_image);
							$.datetimeofp2ppreviousmessage = '';
							$.previoussenderid = '';                                      
						}
						$('#groupMsgReader').animate({ scrollTop: $('#groupMsgReader').get(0).scrollHeight }, 1500);
	                } else {
	                	var incomming_message_client_id = message_obj.message_client_id;
	                	var icon = "img/like-icon-grey.png";
	                	if (message_obj.hasOwnProperty('attachment_type')) {
                            leftAttachmentChatBox(message_obj,channel_name,'',datetime,'#groupMsgReader','group',icon);
                            $('#groupMsgReader').animate({ scrollTop: $('#groupMsgReader').get(0).scrollHeight }, 1500);
                        }else{
                            // 
                            // if message can be merged to last message
                            leftMessageChatBox(message_obj,channel_name,'',datetime,'#groupMsgReader','group',icon);	
                            $.previoussenderid = message_obj.sender.id;
	                        safeMessage($('#'+incomming_message_client_id+' .message')); 
	                        Utility.linkifyMessage($('#'+incomming_message_client_id+' .message'));
		                    emojifyMessage($('#'+incomming_message_client_id+' .message'));
		                    stickerFry('#'+incomming_message_client_id+' .message');                             
                        }   	                    
						$('#groupMsgReader').animate({ scrollTop: $('#groupMsgReader').get(0).scrollHeight }, 1500);
	                }
	              }
	            } else { // if role/group chat window is closed
					// 
					// ignore notification if message sender and current user both are same
					if (message_obj.sender.id != current_user_id) {
						// 
						// this will skip firing notification if message object is a like message.
						if (message_obj.is_liking == "0") { 
					        var bubble_counter = $(".group-message-btn[data-group-id='" + group.group_id + "']").find('span.bubbleCountCustom');
					        var count = parseInt(bubble_counter.text()) + 1
					        bubble_counter.text(count);
					        bubble_counter.show();
					        // Show notifications on status bar with beep
					        // 
					        if(isNaN(count)){
					            statusBarMessage(group.group_name, "1" + " New Message");	
					        }else{
					            statusBarMessage(group.group_name, count + " New Message");	
					        }
					        
						};	
					}               
	            }
		    }
		})
	});
	// end of subscription to group channels

	$(document).on('click', '#groupListView .group-message-btn',function(e){
		
		var group_id = $(this).attr('data-group-id');
		var channel_name = group_id + '_group_channel';
		var group_name = $(this).find('.mainChatName').text();
		
		var group_creator_id = $(this).attr('data-group-creator-id')
        window.group_creator_id = group_creator_id
        $.datetimeofpreviousmessage = ''
		$.mobile.changePage('#group-message');
		// $('.groupLeaveButton').remove()
		$('#groupMsgReader').html(''); // clear meggare reader
		$('#groupMsgReader').attr('data-channel-name', channel_name); // append channel name to message reader to identify
		$('#sendGroupMessageButton').attr('data-channel-name', channel_name);
		$('#sendGroupMessageButton').attr('data-group-id', group_id);
		$('#sendGroupMessageButton').attr('data-chat-type', 'group');
		$('#sendGroupMessageButton').attr('data-sender-id', current_user_id);
		$('#groupNameInline').text(group_name);
        $('#groupNameInline').attr('data-group-type', 'group');
        $('#groupNameInline').attr('data-group-id', group_id);
        $('#groupMsgInput').val('');
		// if($('#sendGroupMessageButton').attr('data-chat-type') == 'group') {
		// 	$('#groupattachmentToggler').before('<a href="#" id="groupLeaveButton" class="fRight headerButt groupLeaveButton"><img src="img/leave-group-icon.png" class="pAbsolute right10 leave_group"/></a>');
		// }        

        // 
        // set chat background image
        if (localStorage["chat_wallpaper"]) {
            $('#group-message').css("background-image", "url("+localStorage["chat_wallpaper"]+")")
            $('#group-message').css("background-repeat", "repeat");
        }
		else{
                $('#group-message').css("background-image", "url('img/pattern-bg-white.png')")
                $('#group-message').css("background-repeat", "repeat")
            };        

        // reset bubble counter
        var bubble_counter = $(".group-message-btn[data-group-id='"+group_id+"']").find('span.bubbleCountCustom');
        bubble_counter.text(0);
        bubble_counter.hide();		

        loadChatHistory(channel_name, '#groupMsgReader', 'group'); // load group chat histories
	});
});