$().ready(function () {
    var new_group_name;

    // 
    // Skip browser history
    $("#GoToCustomGroupStep1").click(function (e) {
        
        e.stopPropagation();
        e.preventDefault();

        $.mobile.changePage(this.href, {
            changeHash: false
        });
    });

    $('#custom-group-step1-next').on('click', function (e) {
        if(!$(this).attr('disabled')){
            e.stopPropagation();
            e.preventDefault();
            $('#custom-group-step1-next').attr('disabled','true')
            var group_name_imput_value = $('#custom-group-subject-input').val();
            if (group_name_imput_value == "") {
                //navigator.notification.alert("Group subject can not be blank.", null, "New Group", "Ok");
                alert("Group subject can not be blank.");
                $('#custom-group-step1-next').removeAttr('disabled')
            } else {
                window.new_group_name = group_name_imput_value

                // step 2 functionality start
                var selected_user_ids = [];
                $('#newGroupContactListView input:checkbox:checked').each(function () {
                    selected_user_ids.push($(this).attr('data-user-id'));
                })

                if (selected_user_ids.length == 0) {
                    //navigator.notification.alert("Atleast 1 contact must be selected.", null, "New Group", "Ok");
                    alert("Atleast 1 contact must be selected.")
                    $('#custom-group-step1-next').removeAttr('disabled')
                } else {
                	$.mobile.loading('show');
                    var current_userinfo = jQuery.parseJSON(localStorage["userinfo"]);
                    var current_user_id = current_userinfo.user_info.user_id;
                    var new_group_name = window.new_group_name;
                    var img_url;

                    if (typeof (window.creategroupimage) == 'undefined' || window.creategroupimage == '' || window.creategroupimage == null) {
                        img_url = ""
                    } else {
                        img_url = $.apiUrl + "/" + window.creategroupimage
                    };

                    // reset release global creategroupimage var
                    window.creategroupimage = "";
                    $.ajax({
                        url: $.apiUrl + "/ccc/api_v1/custom_group",
                        type: "POST",
                        data: {
                            new_group_name: new_group_name,
                            user_ids: '[' + selected_user_ids + ']',
                            group_image: img_url
                        },
                        beforeSend: function (xhr) {
                            xhr.setRequestHeader('token', localStorage["session_token"]);
                        },
                        success: function (json) {
                            var group_name = json.group_name;
                            var group_id = json.group_id;
                            var members_summary = json.members_summary;
                            var group_photo = json.group_image
                            if (group_photo == null || group_photo == '') {
                                group_photo = 'img/group_placeholder.png'
                            } else {
                                group_photo = group_photo
                            }
                            
                            // end of subscription
                            $('#custom-group-subject-input').val(''); //reset custom group subject input
                            $('.user-select-checkbox').attr('checked', false) //reset user select checkbox
                            $.mobile.changePage('#groups'); // go back to groups page
                            $.mobile.loading('hide');
                            $('#custom-group-step1-next').removeAttr('disabled')
                        }
                    });
                };
                // step 2 functionality end
                //$.mobile.changePage('#custom-group-step2', {changeHash:false});
                /*$('#newGroupContactListView').css('height',($(document).height() - ($('.headerPan').height() + $('.ui-footer').height() + $('.ui-input-search').height())).toString() + "px");*/

            };
        }
    });

    $('#save_group_image').on('click', function (e) {
       /* navigator.notification.confirm(
            'Choose picture source!', // message
            ongroupcreateConfirm, // callback to invoke with index of button pressed
            'Choose Picture!', // title
            ['Camera', 'Library'] // buttonLabels
        );*/
    var options = {
                title : "Select image file...",
                types : window.imagetypes,
                typesDescription : "Image files",
                path : "/"
            };

            var curwin = Ti.UI.currentWindow; 
            curwin.openFileChooserDialog( function(fileResponse) { 
                var file = Ti.Filesystem.getFile(fileResponse[0]); 
                desktopUploadGroupPic(file);
            },options);
    })

    var desktopUploadGroupPic = function(file){
            console.log("FILE");
            console.log(file);
            $.mobile.loading('show'); 
            var uploadStream = Ti.Filesystem.getFileStream(file);
        
            uploadStream.open(Ti.Filesystem.MODE_READ);
            content = uploadStream.read();
            uploadStream.close();
        
            console.log("CONTENT");    

            var xhr = Ti.Network.createHTTPClient();
            xhr.addEventListener(Ti.HTTP_DONE, function(){
                //alert('done');
                console.log("TI XHR DONE!");
                console.log(this.responseText);
                //uploadUserPhoto(this.responseText);
                image_url = this.responseText;
                window.creategroupimage = image_url;
                $('#save_group_image').attr('src',$.apiUrl + '/' + window.creategroupimage);
                $.mobile.loading('hide');
                //text.innerHTML += "\n" + this.responseText;
            });
            xhr.addEventListener(Ti.HTTP_STATE_CHANGED, function(){
                //alert('changed');
                console.log("STATE CHANGED");
                console.log(this.responseText);
                //text.innerHTML += "\n" + this.responseText;
            });
            
            xhr.open('POST', $.apiUrl + "/ccc/desktp_file_upload");
            xhr.setRequestHeader("contentType", "multipart/form-data");
            xhr.send({uploadedfile: content,file: file});
    }

    function ongroupcreateConfirm(buttonIndex) {
        var source;
        if (buttonIndex.toString() == "1") {
            source = navigator.camera.PictureSourceType.CAMERA
        } else if (buttonIndex.toString() == "2") {
            source = navigator.camera.PictureSourceType.PHOTOLIBRARY
        } else {
            return false;
        }
        navigator.camera.getPicture(uploadgroupcreatePhotoURISuccess, function (message) {
            return false;
        }, {
            quality: 50,
            destinationType: navigator.camera.DestinationType.FILE_URI,
            sourceType: source
        });
    }


    // Called when a photo is successfully retrieved
    //
    function uploadgroupcreatePhotoURISuccess(imageURI) {
        // Upload the image to server using FileTransfer
        // 
        $.mobile.loading('show');
        var options = new FileUploadOptions();
        options.fileKey = "file";
        options.fileName = imageURI.substr(imageURI.lastIndexOf('/') + 1);
        options.mimeType = "image/jpeg";
        options.headers = {
            Connection: "close"
        }
        options.chunkedMode = false;
        var ft = new FileTransfer();
        ft.upload(
            imageURI,
            encodeURI($.apiUrl + "/ccc/file_upload"),
            function (r) {
                var image_url = r.response.replace(/[\n]/g, "");

                window.creategroupimage = image_url;
                $('#save_group_image').attr('src', $.apiUrl + '/' + window.creategroupimage);
                $.mobile.loading('hide');
            },
            function (error) {
                // alert("An error has occurred: Code = " + error.code);
                // console.log("upload error source " + error.source);
                // console.log("upload error target " + error.target);
                alert("An error has occurred");
            },
            options
        );

    }

    $('#custom-group-step2').on('pageshow', function (event, ui) { //change the name of the group dynamically
        $('#custom-group-step2').find('#groupNameInline').text(window.new_group_name)
    });

    $(document).on('click', '#edit-custom-group-step2-done', function () {
        $.mobile.loading('show');
        var selected_user_ids = [];
        $('#editGroupContactListView input:checkbox:checked').each(function () {
            selected_user_ids.push($(this).attr('data-user-id'));
        });
        if (selected_user_ids.length == 0) {
            navigator.notification.alert("Atleast 1 contact must be selected.", null, window.group_name, "Ok");
            $.mobile.loading('hide');
        } else {
            $.ajax({
                url: $.apiUrl + "/ccc/api_v1/editgroup/" + window.group_id,
                type: "POST",
                data: {
                    user_ids: '[' + selected_user_ids + ']'
                },
                beforeSend: function (xhr) {
                    xhr.setRequestHeader('token', localStorage["session_token"]);
                },
                success: function (data) {
                    $.mobile.loading('hide');
                    $('.group-message-btn').each(function () {
                        if ($(this).attr('data-group-id') == window.group_id) {
                            $(this).find('.mainChatText').text(data.members_summary);
                        }
                    });
                    $.mobile.changePage('#groups');
                }
            });
        }
    });


});