$().ready(function(){
    $('#contactListView .message-btn').on('click', function(e){ // method when clicked on contact list message button
        
        if ($(this).attr('data-channel-name') != null) { // if channel already initiated
            var sender_id       = $(this).attr('data-current-user-id');
            var receiver_id     = $(this).attr('data-user-id');
            var channel_name    = $(this).attr('data-channel-name');
            var receiver_name   = $(this).find('.mainChatName').text();
            $.datetimeofpreviousmessage = '';
            $.mobile.changePage('#message');
            setTimeout(function() {
                 loadChatHistory(channel_name, '#msgReader','p2p');
            }, 100);
           

            $('#sendMessageButton').attr('data-sender-id', sender_id);
            $('#sendMessageButton').attr('data-receiver-id', receiver_id);
            $('#sendMessageButton').attr('data-channel-name', channel_name);

            // 
            // set chat background image
            if (localStorage["chat_wallpaper"]) {

                $('.inner-background-white').css("background-image", "url("+localStorage["chat_wallpaper"]+")");
                $('.inner-background-white').css("background-repeat", "repeat")
                //$('.inner-background-white').css("background-size", "cover")
            }else{
                $('.inner-background-white').css("background-image", "url('img/pattern-bg-white.png')")
                $('.inner-background-white').css("background-repeat", "repeat")
                //$('.inner-background-white').css("background-size", "")
            };
            // 
            // message reciever info inline
            // 
            $('#recieverNameInline').text(receiver_name);
            $('#recieverNameInline').attr('href', '#'+receiver_id+'-page');
            $('#recieverNameInline').attr('data-user-id', receiver_id);
            // 
            // end of message reciever info inline
            // 
        } else if ($(this).attr('data-channel-name') == null) { // if not channel initiated
            var email           = localStorage.getItem("current-user-email");
            var password        = localStorage.getItem("current-user-password");
            var sender_id       = $(this).attr('data-current-user-id');
            var receiver_id     = $(this).attr('data-user-id');
            var receiver_name   = $(this).find('.mainChatName').text();
            $.datetimeofpreviousmessage = ''
            $.ajax({
                url: $.apiUrl + "/ccc/api_v1/init_api",
                type: "POST",
                data: { sender_id: sender_id, receiver_id: receiver_id },
		        beforeSend: function(xhr) { 
                    $.mobile.loading('show');
                    xhr.setRequestHeader('token', localStorage["session_token"]);
                },
		        complete: function(jqXHR, textStatus) { $.mobile.loading('hide'); },
                success: function(json){
                    var channel_name = json.channel;

                    $.mobile.changePage('#message');
                    loadChatHistory(channel_name, '#msgReader', 'p2p');

                    // 
                    // set chat background image
                    if (localStorage["chat_wallpaper"]) {
                        $('.inner-background-white').css("background-image", "url("+localStorage["chat_wallpaper"]+")")
                        $('.inner-background-white').css("background-repeat", "repeat")
                        //$('.inner-background-white').css("background-size", "cover")
                    }else{
                        $('.inner-background-white').css("background-image", "url('img/pattern-bg-white.png')")
                        $('.inner-background-white').css("background-repeat", "repeat")
                       // $('.inner-background-white').css("background-size", "")
                    };

                    // 
                    // add channel name to contact row
                    // 
                    $(this).attr('data-channel-name', channel_name);
                    console.log(channel_name);
                    // 
                    // append sender reciever and channel to chat button
                    // 
                    $('#sendMessageButton').attr('data-sender-id', sender_id);
                    $('#sendMessageButton').attr('data-receiver-id', receiver_id);
                    $('#sendMessageButton').attr('data-channel-name', channel_name);
                    $('#msgReader').attr('data-channel-name', channel_name); // append channel name to message reader to identify
                    // 
                    // message reciever info inline
                    // 
                    $('#recieverNameInline').text(receiver_name);
                    $('#recieverNameInline').attr('href', '#'+receiver_id+'-page');
                    $('#recieverNameInline').attr('data-user-id', receiver_id);
                    // 
                    // end of message reciever info inline
                    // 
                },
                error: function(){
                    $.mobile.changePage('#message');
                    // 
                    // message reciever info inline
                    // 
                    $('#recieverNameInline').text(receiver_name);
                    $('#recieverNameInline').attr('href', '#'+receiver_id+'-page');
                    $('#recieverNameInline').attr('data-user-id', receiver_id);
                    // 
                    // end of message reciever info inline
                    //                     
                }
            });
        };

        // disable message input and button
        if ($(this).hasClass('can-not-message')) {
            $('#msgInput').attr('disabled', 'disabled')
            $('#sendMessageButton').hide();
            $('#p2pOptionsTogeller').hide();
            $('#attachmentToggler').hide();
        } else if ($('#msgInput').attr('disabled') == 'disabled') {
            $('#msgInput').removeAttr('disabled')
            $('#sendMessageButton').show(); 
            $('#p2pOptionsTogeller').show();
            $('#attachmentToggler').show();
        };
        // end

        // reset bubble counter
        var bubble_counter = $(".message-btn[data-channel-name='"+channel_name+"']").find('span.bubbleCountCustom');
        bubble_counter.text(0);
        bubble_counter.hide();

        $('#msgReader').html(''); // reset message reader block
        $('#msgInput').val(''); // reset message input block
        $('#msgReader').attr('data-channel-name', channel_name); // append channel name to message reader to identify
    }); // method end

    $('#sendMessageButton').on('click', function(e){ // chat submit
        var channel_name = $(this).attr('data-channel-name');
        var sender_id = $(this).attr('data-sender-id');
        var receiver_id = $(this).attr('data-receiver-id');
        var message = encodeHTML($('#msgInput').val());
		var message_client_id = (sender_id+'_'+($.now()));
//        var networkState = navigator.connection.type;
        var font_style = localStorage["chat_font_style"];

        vibrate($.vibrateduration)
        //p2p first time message receiving issue temporary fix
        //
        var pubnub = PUBNUB.init({ publish_key: $.pubnubkeys.publish_key, subscribe_key: $.pubnubkeys.subscribe_key });
        pubnub.publish({channel: localStorage.org_channel, message: '{"event":"init-chat","channel_name": "'+ channel_name + '" ,"message":"Fix"}'});
        
        if ($.trim(message).length == 0) {
            alert('Please write some message.')
        } else {
            $('#msgReader').append( // sender append chat message
                '<div class="fRight mLeft8 chatRight" id="'+ message_client_id +'"><span class="chatRightArrow"><img src="img/chat-right.gif" alt="" /></span><p class="message"></p><p class="date"><span><img src="img/schedule-clock.png" width="9"/></span></p></div><div class="clear"></div>'
            );
            hideOptionsP2p(); // hide emotions list
            $('#msgInput').val(''); // clear message input values
            $('#msgInput').css('height', '29px'); // reset message box height
            $('#'+message_client_id+' .message').text(message);
            safeMessage($('#'+message_client_id+' .message'));
            Utility.linkifyMessage($('#'+message_client_id+' .message'));
            emojifyMessage($('#'+message_client_id+' .message'));
            stickerFry('#'+message_client_id+' .message');
            $('#msgReader').animate({ scrollTop: $('#msgReader').get(0).scrollHeight }, 1500);
            current_msg_obj = {
                                        "sender": {
                                            "id": sender_id,
                                            "name": '',
                                            "photo": ''
                                        },
                                        "receiver": {
                                            "id": receiver_id,
                                            "name": '',
                                            "photo": ''
                                        },
                                        "message_id": $.offline_message_id,
                                        "channel_name": channel_name,
                                        "message": message,
                                        "date": '',
                                        "message_client_id": message_client_id,
                                        "time": '',
                                        "merge_to_last_message": 'false',
                                        "textformat": '',
                                        "allowed_suborg_ids": 'undefined',
                                        "group": {
                                            "id": 'undefined',
                                            "name": 'undefined'
                                        },
                                        "role": {
                                            "id": 'undefined',
                                            "name": 'undefined'
                                        },
                                        "like_count": '0',
                                        "like_status": '0',
                                        "is_liking": '0'
            }
            saveMessageToDB(current_msg_obj);
            $.ajax({
                url: $.apiUrl + "/ccc/api_v1/message_api",
                type: "POST",
                data: {
                    json: '{"device_info":[{"app_name":"CCC","sync_protocol_version":"2.3","UDID":"6A33CA4E-E897-56E1-8C1A-A9FAD1ADC763","uptime":"1351504964"}],"user_info":[{"user_id":"'+sender_id+'"}],"message_log": [{"message_id":"0","message_parent":"0","message_state":"new", "message_type": "unicast-people","recipient_role":"","message_recipients":"'+receiver_id+'","message": "'+message+'","reply_permitted": "0","call_permitted":"0","date": "1351504974.083523","TZ":"GMT+05:30","events":[{"TZ":"GMT+05:30","event_time_start":"1351504926.000000","event_time_end":"1351677727.000000","location":"Delhi","solicit_response":"1"}],"attachments":"0"}]}',
                    channel_name: channel_name,
                    channel_event: 'message',
					message_client_id: message_client_id,
                    text_format: font_style
                },
		        beforeSend: function(xhr) {        
                    xhr.setRequestHeader('token', localStorage["session_token"]);
		        },
                success: function(){
                     
                },
                error: function(xhr, textStatus, errorThrown){
                    //handle error
                    $('#'+message_client_id+' .date').html('<img src="img/schedule-clock.png" width="9">');
                    //$.ajax(this); //retry
                }
            });
        };

        // 
        //  Offline error message
        /*if (networkState == Connection.NONE) {
            alert("You are offline");
            $('#'+message_client_id).hide();
        };*/

        // 
        // apply font style
        if (font_style) {
            $('#'+message_client_id+' .message').addClass('font-'+font_style);
        };


        e.preventDefault();
    }); // end of chat submit 
      
    // submit sendMessage form on pressing the enter button
    $('#msgInput').keypress(function (e) {
      if (e.which == 13) {
        $('#sendMessageButton').trigger('click');
		e.preventDefault();
      }
    });     
});