$().ready(function(){
    var current_userinfo = jQuery.parseJSON(localStorage["userinfo"]);
	var current_user_id  = current_userinfo.user_info.user_id;
	var roles_json       = jQuery.parseJSON(localStorage["hris_enterprise_chat_roles"]);
    var suborg_id        = current_userinfo.user_info.suborg;

    // subscribe role based channels
    // 
    var pubnub = PUBNUB.init({
        publish_key: $.pubnubkeys.publish_key,
        subscribe_key: $.pubnubkeys.subscribe_key
    });

	$.each(roles_json, function(i, role) {
		var channel_name = role.role_id + '_role_channel';
		pubnub.subscribe({
		    channel: channel_name,
		    message: function (m) {
                console.log("role bases subscribe");
                console.log(m);
		    	var message_obj = jQuery.parseJSON(m);
                var date;
                var datetime;
                datetime = datify(message_obj);
                if(message_obj.message){
                            if(message_obj.message.is_liking == "1"){
                                if(message_obj.message.like_count.toString() == "0"){
                                    $("#"+ message_obj.message.id).next().text("");
                                }else{
                                    $("#"+ message_obj.message.id).next().text(" + " + message_obj.message.like_count );    
                                }
                                
                            }
                }
                if(typeof(message_obj.message) != "undefined"){
                            if(message_obj.message.is_liking == "1"){
                                updatelikestatus(message_obj)
                            }else{
                                saveMessageToDB(message_obj)
                            }
                }else{
                            saveMessageToDB(message_obj)
                }

                if ($.inArray(parseInt(suborg_id), eval(message_obj.allowed_suborg_ids)) !== -1){ // if user has authority to view message from sub organization
                    // append/save/cache to history
                                        
                    if ($("#groupMsgReader[data-channel-name='" + channel_name + "']:visible").length > 0) { // if role/group chat window is open
                        
                        if (message_obj.sender.id == current_user_id){

                            if(message_obj.is_liking == "0"){
							 $("#"+ message_obj.message_client_id +" .date").html('<span>'+datetime+'</span>');
                             $("#"+ message_obj.message_client_id +" .date").addClass('pRelative');
                             $("#"+ message_obj.message_client_id +" .date").append(likeRoleRight(message_obj,channel_name,"img/like-icon-grey-rev.png"));

                             $("#" + message_obj.message_client_id + " .attachment-image-message").attr('src',message_obj.video_image);                                      
                             $('#groupMsgReader').animate({ scrollTop: $('#groupMsgReader').get(0).scrollHeight }, 1500);
                             $.datetimeofp2ppreviousmessage = '';
                             $.previoussenderid = '';
                            }
                        } else {
                            var icon = "img/like-icon-grey.png";
                            if (message_obj.hasOwnProperty('attachment_type')) {
                                leftAttachmentChatBox(message_obj,channel_name,'',datetime,'#groupMsgReader','role',icon);
                                $('#groupMsgReader').animate({ scrollTop: $('#groupMsgReader').get(0).scrollHeight }, 1500);
                            }else{
                                var incomming_message_client_id = message_obj.message_client_id;
                                leftMessageChatBox(message_obj,channel_name,'',datetime,'#groupMsgReader','role',icon); 
                                safeMessage($('#' + incomming_message_client_id + ' .message'));
                                Utility.linkifyMessage($('#' + incomming_message_client_id + ' .message'));
                                emojifyMessage($('#' + incomming_message_client_id + ' .message'));
                                stickerFry('#' + incomming_message_client_id + ' .message');
                                // apply font style
                                if (message_obj.textformat != '') {
                                    $('#'+incomming_message_client_id+' .message').addClass('font-'+message_obj.textformat);
                                };                                  
                            }
							$('#groupMsgReader').animate({ scrollTop: $('#groupMsgReader').get(0).scrollHeight }, 1500);
                            $.previoussenderid = message_obj.sender.id
                        }
                    } else { // if role/group chat window is closed
                        // 
                        // ignore notification if message sender and current user both are same
                        if (message_obj.sender.id != current_user_id) {
                            if (message_obj.is_liking == "0") { // this will skip firing notification if message object is a like message.
                                var bubble_counter = $(".role-group-message-btn[data-group-id='" + role.role_id + "']").find('span.bubbleCountCustom');
                                var count = parseInt(bubble_counter.text()) + 1
                                bubble_counter.text(count);
                                bubble_counter.show();

                                // Show notifications on status bar with beep
                                // 
                                if(isNaN(count)){
                                    statusBarMessage(role.role_name, "1" + " New Message");  
                                }else{
                                    statusBarMessage(role.role_name, count + " New Message");  
                                }
                                
                            };     
                        }                         
                    }
                }
		    }
		});
	});
	// subscribe role based channels

	$(document).on('click', '#groupListView .role-group-message-btn',function(e){
        
		var role_id = $(this).attr('data-group-id');
		var channel_name = role_id + '_role_channel';
		var group_name = $(this).find('.mainChatName').text();
        var suborg_id = current_userinfo.user_info.suborg;
        $.datetimeofpreviousmessage = '';
		$.mobile.changePage('#group-message');
        // $('.groupLeaveButton').remove()
        $('#groupMsgReader').html(''); // clear meggare reader
		$('#groupMsgReader').attr('data-channel-name', channel_name); // append channel name to message reader to identify
		$('#sendGroupMessageButton').attr('data-channel-name', channel_name);
        $('#sendGroupMessageButton').attr('data-chat-type', 'role');
        $('#sendGroupMessageButton').attr('data-group-id', role_id);
        $('#sendGroupMessageButton').attr('data-sender-id', current_user_id);
		$('#groupNameInline').text(group_name);
        $('#groupNameInline').attr('data-group-type', 'role');
        $('#groupNameInline').attr('data-group-id', role_id);
        $('#groupMsgInput').val('');
        // 
        // set chat background image
        if (localStorage["chat_wallpaper"]) {
            $('#group-message').css("background-image", "url("+localStorage["chat_wallpaper"]+")")
                               .css("background-repeat", "repeat")
        };

        // reset bubble counter
        var bubble_counter = $(".role-group-message-btn[data-group-id='"+role_id+"']").find('span.bubbleCountCustom');
        bubble_counter.text(0);
        bubble_counter.hide();		

        loadRoleBasedChatHistory(channel_name, '#groupMsgReader', suborg_id); // load chat histories

        // disable message input and button
        if ($(this).hasClass('can-not-message')) {
            $('#groupMsgInput').attr('disabled', 'disabled')
            $('#sendGroupMessageButton').hide();
            $('#groupOptionsTogeller').hide();
            $('#groupattachmentToggler').hide();
        } else if ($('#groupMsgInput').attr('disabled') == 'disabled') {
            $('#groupMsgInput').removeAttr('disabled')
            $('#sendGroupMessageButton').show(); 
            $('#groupOptionsTogeller').show();
            $('#groupattachmentToggler').show();
        };
        // end
	});

    // common for group and role
    $('#sendGroupMessageButton').on('click', function(e){ // chat submit
        var channel_name = $(this).attr('data-channel-name');
        var sender_id = current_user_id;
        var message = encodeHTML($('#groupMsgInput').val());
		var message_client_id = (sender_id+'_'+($.now()));
//        var networkState = navigator.connection.type;
        var font_style = localStorage["chat_font_style"];
        var allowed_suborg_ids = ''
        vibrate($.vibrateduration)

        if ($("#sendGroupMessageButton[data-chat-type='group']").size() > 0) {
            var group_id = parseInt(channel_name);
            var json_str = '{"device_info":[{"app_name":"CCC","sync_protocol_version":"2.3","UDID":"6A33CA4E-E897-56E1-8C1A-A9FAD1ADC763","uptime":"1351504964"}],"user_info":[{"user_id":"'+sender_id+'"}],"message_log": [{"message_id":"0","message_parent":"0","message_state":"new", "message_type": "unicast-role","recipient_group":"'+group_id+'","message_recipients":"","message": "'+message+'","reply_permitted": "0","call_permitted":"0","date": "1351504974.083523","TZ":"GMT+05:30","attachments":"0"}]}'
        }else{
            var role_id = parseInt(channel_name);

            allowed_suborg_ids = '[0]'
            var json_str = '{"device_info":[{"app_name":"CCC","sync_protocol_version":"2.3","UDID":"6A33CA4E-E897-56E1-8C1A-A9FAD1ADC763","uptime":"1351504964"}],"user_info":[{"user_id":"'+sender_id+'"}],"message_log": [{"message_id":"0","message_parent":"0","message_state":"new", "message_type": "unicast-role","recipient_role":"'+role_id+'","message_recipients":"","message": "'+message+'","reply_permitted": "0","call_permitted":"0","date": "1351504974.083523","TZ":"GMT+05:30","attachments":"0"}]}'
        };
        console.log(json_str)
        if ($.trim(message).length == 0) {
            alert('Please write some message.')
        } else {
            $('#groupMsgReader').append( // sender append chat message
                '<div class="fRight mLeft8 chatRight" id="'+ message_client_id +'"><span class="chatRightArrow"><img src="img/chat-right.gif" alt="" /></span><p class="message">' + message + '</p><p class="date"><span><img src="img/schedule-clock.png" width="9"/></span></p></div><div class="clear"></div>'
            );
            hideOptionsGroup(); // hide emotions list
            $('#groupMsgInput').val(''); // clear message input values
            $('#groupMsgInput').css('height', '29px'); // reset message box height
            $('#'+message_client_id+' .message').text(message);
            safeMessage($('#'+message_client_id+' .message'));
            Utility.linkifyMessage($('#'+message_client_id+' .message'));
            emojifyMessage($('#'+message_client_id+' .message')); // emojify last message
            stickerFry('#'+message_client_id+' .message'); // emojify last message
            $('#groupMsgReader').animate({ scrollTop: $('#groupMsgReader').get(0).scrollHeight }, 1500);

            current_msg_obj = {
                                "sender": {
                                    "id": sender_id,
                                    "name": '',
                                    "photo": ''
                                },
                                "receiver": {
                                    "id": '',
                                    "name": '',
                                    "photo": ''
                                },
                                "message_id": $.offline_message_id,
                                "channel_name": channel_name,
                                "message": message,
                                "date": '',
                                "message_client_id": message_client_id,
                                "time": '',
                                "merge_to_last_message": 'false',
                                "textformat": '',
                                "allowed_suborg_ids": allowed_suborg_ids,
                                "group": {
                                    "id": group_id,
                                    "name": ''
                                },
                                "role": {
                                    "id": role_id,
                                    "name": ''
                                },
                                "like_count": '0',
                                "like_status": '0',
                                "is_liking": '0'
            }
            saveMessageToDB(current_msg_obj);
            $.ajax({
                url: $.apiUrl + "/ccc/api_v1/message_api",
                type: "POST",
                data: {
                    json: json_str,
                    channel_name: channel_name,
                    channel_event: 'group-message',
					message_client_id: message_client_id,
                    text_format: font_style
                },
		        beforeSend: function(xhr) {
                    xhr.setRequestHeader('token', localStorage["session_token"]);
		        },
                success: function(){

                },
                error: function(){
                    $('#'+message_client_id+' .date').html('<img src="img/schedule-clock.png" width="9">');
                    //$.ajax(this); //retry
                }
            });
        };

        // 
        //  Offline error message
        /*if (networkState == Connection.NONE) { 
            alert("You are offline")
            $('#'+message_client_id).hide();
        };*/

        // 
        // apply font style
        if (font_style) {
            $('#'+message_client_id+' .message').addClass('font-'+font_style);
        };

        e.preventDefault();
    }); // end of chat submit

   // submit sendMessage form on pressing the enter button
   $('#groupMsgInput').keypress(function (e) {
        if (e.which == 13) {
        $('#sendGroupMessageButton').trigger('click');
		e.preventDefault();
     }
   });
});

// get history messages
function loadRoleBasedChatHistory(channel_name, targetDOM, suborg_id) { // get history messages
    var current_userinfo = jQuery.parseJSON(localStorage["userinfo"]);
    var current_user_id  = current_userinfo.user_info.user_id;

    // fetch cached messages
        
            var current_userinfo = jQuery.parseJSON(localStorage["userinfo"]);
            var current_user_id  = current_userinfo.user_info.user_id;
            var messages = getMessagesFromDB(channel_name)//, function(messages){
            plotRoleBasedMessages(messages, current_user_id, channel_name, targetDOM, suborg_id);
            //});
   
}; // end of history messages


function plotRoleBasedMessages(messages, current_user_id, channel_name, targetDOM, suborg_id) {

    // currently a hach 
    // for showing and hiding pagination bar
    if (messages.length >= $.pagination_size) {
        $('#loadOldMessagesForGroup').show();
        $('#loadOldMessagesForGroup').attr('data-offset', '0');
        $('#loadOldMessagesForGroupPlaceHolder').show();
    }else{
        $('#loadOldMessagesForGroup').hide();
        $('#loadOldMessagesForGroupPlaceHolder').hide();
    };
     var history_type = 'role';
    for (var i = 0; i < messages.length; i++) {
        try
        {
            var message_obj = messages[i];
            //if ($.inArray(parseInt(suborg_id), eval(message_obj.allowed_suborg_ids)) !== -1){ // if user has authority to view message from sub organization
                console.log(message_obj);
                
                var date;
                var datetime;
                datetime = datify(message_obj);
                var unsentnote = "img/ExclamationMark.png";
                if (typeof message_obj.like_count === "undefined") {
                    message_obj.like_count = "0";
                }
                
                // if (message_obj.sender) {
                    if (message_obj.sender.id == current_user_id){
                        var icon ="";
                        if(message_obj.like_status == "1"){
                            icon = "img/like-icon-rev.png"
                        }else{
                            icon = "img/like-icon-grey-rev.png"
                        }
                        $.previoussenderid = '';
                        $.datetimeofp2ppreviousmessage = '';
                        if (message_obj.hasOwnProperty('attachment_type')) {
                            rightAttachmentChatBox(message_obj,channel_name,unsentnote,datetime,targetDOM,history_type,icon);    
                        }else{
                            rightMessageChatBox(message_obj,channel_name,unsentnote,datetime,targetDOM,history_type,icon);                                       
                        }                                              
                    } else {
                        var icon ="";
                        if(message_obj.like_status == "1"){
                            icon = "img/like-icon.png"
                        }else{
                            icon = "img/like-icon-grey.png"
                        }
                         if (message_obj.hasOwnProperty('attachment_type')) {
                            leftAttachmentChatBox(message_obj,channel_name,unsentnote,datetime,targetDOM,history_type,icon);
                         }else{
                            leftMessageChatBox(message_obj,channel_name,unsentnote,datetime,targetDOM,history_type,icon);  
                            $.previoussenderid = message_obj.sender.id                                      
                         }   
                    } 
        }catch(e){}        
    }
    safeMessageAll(targetDOM);
    Utility.linkifyMessages(targetDOM);
    emojifyMessageAll(targetDOM);
    stickerFry(targetDOM); // emojify last message
    $(targetDOM).animate({ scrollTop: $(targetDOM).get(0).scrollHeight }, 1500);
};
