$().ready(function () {
    var current_userinfo = jQuery.parseJSON(localStorage["userinfo"]);
    var current_user_id = current_userinfo.user_info.user_id;
    $('#contactListView .message-btn').attr('data-current-user-id', current_user_id);

    // initiate current user channel
    var pubnub = PUBNUB.init({
        publish_key: $.pubnubkeys.publish_key,
        subscribe_key: $.pubnubkeys.subscribe_key
    });
    pubnub.subscribe({
        channel: "unsubscribe_group_channel",
        message: function (m) {
            var group_info_object = JSON.parse(m);
            if(group_info_object.message.event.toString() == "group-edited"){
                if($.inArray(parseInt(current_user_id),eval(group_info_object.message.existing_user_ids)) != -1){
                    //append if group member added
                }
                $('#groupListView').find('.divRows').each(function(){
                    window.group_creator_id = group_info_object.message.creator_id
                    if($(this).find('.custom-group').attr('data-group-id') == group_info_object.message.group_id){
                        $(this).find('.custom-group').attr('data-group-creator-id',group_info_object.message.creator_id);
                        $(this).find('.custom-group').find('.mainChatText').text(group_info_object.message.member_names);
                        if($.inArray(parseInt(current_user_id),eval(group_info_object.message.existing_user_ids)) == -1){
                            $(this).hide();
                        }else{
                            $(this).show();
                        }
                    }
                });
            }else if(group_info_object.message.event.toString() == "group-deleted"){
                $('#groupListView').find('.divRows').each(function(){
                    if($(this).find('.custom-group').attr('data-group-id') == group_info_object.message.group_id){
                        $(this).remove();
                    }
                });
            }else{
                window.group_creator_id = group_info_object.message.creator_id
                $('#groupListView').find('.divRows').each(function(){
                    if($(this).find('.custom-group').attr('data-group-id') == group_info_object.message.group_id){
                            $(this).find('.custom-group').attr('data-group-creator-id',group_info_object.message.creator_id);
                            $(this).find('.custom-group').find('.mainChatText').text(group_info_object.message.member_names);
                    }
                });    
            }
            
            $.ajax({
                    url: $.apiUrl + '/index.php/ccc/api_v1/contacts',
                    beforeSend: function (xhr) {
                        $.mobile.loading('show');
                        xhr.setRequestHeader('token', localStorage["session_token"]);
                    },
                    success: function (json) {
                        localStorage.hris_enterprise_chat_groups    = JSON.stringify(json.groups);
                    },
                    error: function (json) {
                        alert('Error fetching updated contact list from server.')
                    },
                    complete: function(jqXHR, textStatus) { 
                        $.mobile.loading('hide'); 
                    }
            });
        }
    });

    pubnub.subscribe({
        channel: current_user_id + "_user_channel",
        message: function (m) { // {"event":"new-custom-group-initiated","channel_name":"100_group_channel", "group_id": 100,"message":"New Group GROUP-NAME initiated by GROUP-CREATOR."} 
            console.log(m);
            var init_group_obj = jQuery.parseJSON(m);
            if (init_group_obj.event == "new-custom-group-initiated") {
                if (init_group_obj.group_image == null || init_group_obj.group_image == '') {
                    group_photo = 'img/group_placeholder.png'
                } else {
                    group_photo = init_group_obj.group_image
                }
                //update the localstorage 
                new_group_obj = new Object();
                new_group_obj.group_creator = init_group_obj.group_creator
                new_group_obj.group_id = init_group_obj.group_id
                new_group_obj.group_image = init_group_obj.group_image
                new_group_obj.group_name = init_group_obj.group_name
                new_group_obj.members_summary = init_group_obj.members_summary
                existing_groups = jQuery.parseJSON(localStorage["hris_enterprise_chat_groups"]);
                existing_groups.unshift(new_group_obj);
                latest_groups = JSON.stringify(existing_groups);
                localStorage["hris_enterprise_chat_groups"] = latest_groups
                //localstorage updated
                
                var new_group_row;
                if(current_user_id == init_group_obj.group_creator){
                    new_group_row = '<div class="mainChatBdrBott divRows">' +
                                    '<span class="user-detail-btn pAbsolute grpDetails smallThumbPic">' +
                                    '<img src="' + group_photo + '" height="46px">' +
                                    '</span>' +
                                    '<img src="img/group-admin.png" class="pAbsolute right10" width="24px">' +
                                    '<div class="mLeft54 pRelative group-message-btn custom-group" data-group-creator-id="' + current_user_id + '" data-group-id="' + init_group_obj.group_id + '">' +
                                    '<div class="fLeft mLeft8 group-chat-name wp89">' +
                                    '<p class="mainChatName">' + init_group_obj.group_name + '</p>' +
                                    '<p class="mainChatText text-truncate">' + init_group_obj.members_summary + '</p>' +
                                    '<div class="chatDate">' +
                                    '<span class="bubbleCountCustom fLeft hide">0</span>' +
                                    '</div>' +
                                    '</div>' +
                                    '<div class="clear"></div>' +
                                    '</div>' +
                                    '<div class="clear"></div>' +
                                    '</div>'
                }else{
                    new_group_row = '<div class="mainChatBdrBott divRows">' +
                                    ' <span class="user-detail-btn pAbsolute grpDetails smallThumbPic">' +
                                    '<img src="' + group_photo + '" height="46px">' +
                                    '</span>' +
                                    '<img src="img/group-icon.png" class="pAbsolute right10" width="24px">' +
                                    '<div class="mLeft54 pRelative group-message-btn custom-group" data-group-creator-id="' + init_group_obj.group_creator + '" data-group-id="' + init_group_obj.group_id + '">' +
                                    '<div class="fLeft mLeft8 group-chat-name wp89">' +
                                    '<p class="mainChatName">' + init_group_obj.group_name + '</p>' +
                                    '<p class="mainChatText text-truncate">' + init_group_obj.members_summary + '</p>' +
                                    '<div class="chatDate">' +
                                        '<span class="bubbleCountCustom fLeft hide">0</span>' +
                                    '</div>' +
                                    '</div>' +
                                    '<div class="clear"></div>' +
                                    '</div>' +
                                    '<div class="clear"></div>' +
                                    '</div>'
                }
                
                $('#groupListView').prepend(new_group_row);

                // subscribe to newly created group                    
                var channel_name = init_group_obj.group_id + '_group_channel';
                pubnub.subscribe({
                    channel: channel_name,
                    message: function (m) {
                        var group_message_obj = jQuery.parseJSON(m);
                        console.log(m)
                        // append/save/cache to history
                        var date;
                        var datetime;
                        datetime = datify(group_message_obj);
                        if(typeof(group_message_obj.message) != "undefined"){
                            if(group_message_obj.message.is_liking == "1"){
                                    updatelikestatus(group_message_obj)
                            }else{
                                saveMessageToDB(group_message_obj)
                            }
                        }else{
                                saveMessageToDB(group_message_obj)
                        }

                        if ($("#groupMsgReader[data-channel-name='" + channel_name + "']").length > 0) { // if role/group chat window is open
                            if(group_message_obj.message){
                                if(group_message_obj.message.is_liking == "1"){
                                    if(group_message_obj.message.like_count.toString() == "0"){
                                        $("#"+ group_message_obj.message.id).next().text("");
                                    }else{
                                        $("#"+ group_message_obj.message.id).next().text(" + " + group_message_obj.message.like_count);
                                    }
                                    
                                }
                            }
                            if(group_message_obj.sender){
                            if (group_message_obj.sender.id == current_user_id) {
                                $("#" + group_message_obj.message_client_id + " .date").html('<span>'+datetime+'</span>');
                                $("#" + group_message_obj.message_client_id + " .date").addClass('pRelative');
                                $("#" + group_message_obj.message_client_id + " .date").append(likeGroupRight(group_message_obj,channel_name,"img/like-icon-grey.png")); 
                                $("#" + group_message_obj.message_client_id + " .attachment-image-message").attr('src',group_message_obj.video_image);
                                $('#groupMsgReader').animate({ scrollTop: $('#groupMsgReader').get(0).scrollHeight }, 1500);
                                $.datetimeofp2ppreviousmessage = '';
                                $.previoussenderid = '';
                            } else {
                                var icon = "img/like-icon-grey.png"
                                if (group_message_obj.hasOwnProperty('attachment_type')) {
                                    leftAttachmentChatBox(group_message_obj,channel_name,'',datetime,'#groupMsgReader','group',icon);
                                    $('#groupMsgReader').animate({ scrollTop: $('#groupMsgReader').get(0).scrollHeight }, 1500);
                                }else{
                                    var incomming_message_client_id = group_message_obj.message_client_id;
                                    leftMessageChatBox(group_message_obj,channel_name,'',datetime,'#groupMsgReader','group',icon);
                                    safeMessage($('#' + incomming_message_client_id + ' .message'));     
                                    Utility.linkifyMessage($('#' + incomming_message_client_id + ' .message'));
                                    emojifyMessage($('#' + incomming_message_client_id + ' .message'));
                                    stickerFry('#' + incomming_message_client_id + ' .message');   
                                    // apply font style
                                    if (group_message_obj.textformat != '') {
                                        $('#'+incomming_message_client_id+' .message').addClass('font-'+group_message_obj.textformat);
                                    }; 
                                    $.previoussenderid = group_message_obj.sender.id                                                                   
                                }   
                                $('#groupMsgReader').animate({ scrollTop: $('#groupMsgReader').get(0).scrollHeight }, 1500);         
                            }
                          }
                        } else { // if role/group chat window is closed
                            // 
                            // ignore notification if message sender and current user both are same
                            if (group_message_obj.sender.id != current_user_id) {
                                // 
                                // this will skip firing notification if message object is a like message.
                                if (group_message_obj.is_liking == "0") { 
                                    var bubble_counter = $(".group-message-btn[data-group-id='" + init_group_obj.group_id + "']").find('span.bubbleCountCustom');
                                    var count = parseInt(bubble_counter.text()) + 1
                                    bubble_counter.text(count);
                                    bubble_counter.show();
                                    // Show notifications on status bar with beep
                                    // 
                                    var group_name = $(".group-message-btn[data-group-id='" + init_group_obj.group_id + "']").find('p.mainChatName').text();
                                    if(isNaN(count)){
                                        statusBarMessage(group_name, "1" + " New Message");
                                    }else{
                                        statusBarMessage(group_name, count + " New Message");
                                    }
                                    
                                };    
                            }   
                        }
                    }
                });
                // end of subscription
            }
        }
    });
    // end of current user channel def
    
    // subscription to organization channel and other p2p dynamically
    $.ajax({
        url: $.apiUrl + "/ccc/api_v1/chanelapi",
        data: {
            user_id: current_user_id
        },
        beforeSend: function (xhr) {
            $.mobile.loading('show');
            xhr.setRequestHeader('token', localStorage["session_token"]);
        },
        complete: function (xhr, textStatus) {
            $.mobile.loading('hide');
        },
        success: function (json) {
            var pubnub = PUBNUB.init({
                publish_key: $.pubnubkeys.publish_key,
                subscribe_key: $.pubnubkeys.subscribe_key,
                uuid: current_user_id
            });
			
			localStorage["org_channel"] = json.channel_name

            pubnub.subscribe({
                channel: json.channel_name,
                message: function (m) {
                    // m = {"event":"init-chat","channel_name":"channel_1858_1865","message":"Arijit Tulal has some message for you"} 
                    var json = jQuery.parseJSON(m);
                    if (json.event == "init-chat") {
                        var splitted_channel_name = json.channel_name.split('_');
                        var selector_condition_1 = $(".message-btn[data-current-user-id='" + splitted_channel_name[1] + "'][data-user-id='" + splitted_channel_name[2] + "']");
                        var selector_condition_2 = $(".message-btn[data-current-user-id='" + splitted_channel_name[2] + "'][data-user-id='" + splitted_channel_name[1] + "']");
                        if ($(".message-btn[data-channel-name='" + json.channel_name + "']").length == 0) {
                            if (json.channel_name.match(current_user_id) != null) {
                                if (selector_condition_1.length > 0) { // add channel name data attribute to message button
                                    selector_condition_1.attr('data-channel-name', json.channel_name)
                                } else if (selector_condition_2.length > 0) {
                                    selector_condition_2.attr('data-channel-name', json.channel_name)
                                }; // end of adding channel name data attribute
                                pubnub.subscribe({
                                    channel: json.channel_name,
                                    message: function (m) {
                                        console.log(m);
                                        var message_obj = jQuery.parseJSON(m);
                                        // append/save/cache to history
                                        var date;
                                        var datetime;
                                        datetime = datify(message_obj);
                                         saveMessageToDB(message_obj);
                                        if ($("#msgReader[data-channel-name='" + json.channel_name + "']").length > 0) { // if chat window is open
                                            if (message_obj.sender.id == current_user_id) {
                                                $("#" + message_obj.message_client_id + " .date").html('<span>'+datetime+'</span>');
                                                $("#" + message_obj.message_client_id + " .attachment-image-message").attr('src',message_obj.video_image);
                                                $('#msgReader').animate({ scrollTop: $('#msgReader').get(0).scrollHeight }, 1500);
                                                $.datetimeofp2ppreviousmessage = '';
                                            } else {
                                                // 
                                                // chack if message contain attachment
                                                if (message_obj.hasOwnProperty('attachment_type')) {
                                                   leftAttachmentChatBox(message_obj,json.channel_name,'',datetime,'#msgReader','p2p','');
                                                   $('#msgReader').animate({ scrollTop: $('#msgReader').get(0).scrollHeight }, 1500); 
                                                } else { // for normal text message
                                                    var incomming_message_client_id = message_obj.message_client_id;
                                                    leftMessageChatBox(message_obj,json.channel_name,'',datetime,'#msgReader','p2p','');
                                                    safeMessage($('#' + incomming_message_client_id + ' .message'));
                                                    Utility.linkifyMessage($('#' + incomming_message_client_id + ' .message'));
                                                    emojifyMessage($('#' + incomming_message_client_id + ' .message'));
                                                    stickerFry('#' + incomming_message_client_id + ' .message');
                                                    // apply font style
                                                    if (message_obj.textformat != '') {
                                                        $('#'+incomming_message_client_id+' .message').addClass('font-'+message_obj.textformat);
                                                    };  
                                                };
                                                $('#msgReader').animate({ scrollTop: $('#msgReader').get(0).scrollHeight }, 1500);
                                            }
                                        } else {
                                            // 
                                            // ignore notification if message sender and current user both are same
                                            if (message_obj.sender.id != current_user_id) {
                                                // 
                                                // Show notifications with bubble counter
                                                var bubble_counter = $(".message-btn[data-channel-name='" + json.channel_name + "']").find('span.bubbleCountCustom');
                                                var count = parseInt(bubble_counter.text()) + 1
                                                bubble_counter.text(count);
                                                bubble_counter.show();
                                                // 
                                                // Show notifications on status bar with beep
                                                if(isNaN(count)){
                                                    statusBarMessage(message_obj.sender.name, "1" + " New Message");
                                                }else{
                                                    statusBarMessage(message_obj.sender.name, count + " New Message");
                                                }
                                            }  
                                            
                                        }
                                    }
                                });
                            };
                        };
                    } else if (json.event == "contact-list-permission-updates") {
                        alert("Contacts permission updated.");
                        reloadContacts();
                    };
                },
                presence: function (message, env, channel) {
                    var OnlineStatusIcon = $('.' + message.uuid + '_online_status_icon');
                    var OfflineStatusIcon = $('.' + message.uuid + '_offline_status_icon');
                    if (message.action == "join") {
                        OfflineStatusIcon.hide();
                        OnlineStatusIcon.show();
                    } else {
                        OnlineStatusIcon.hide();
                        OfflineStatusIcon.show();
                    }
                }
            });
        }
    });
});

$().ready(function () {
    $('.dismissP2PChat').on('click', function (e) { // dismiss chat window and reset data attributes
        $('#msgInput').css('height', '29px'); // reset message box height
        $('#sendMessageButton').attr('data-channel-name', '');
        $('#msgReader').attr('data-channel-name', '');
        // $('#msgInput').textinput('enable');  
        // $('#sendMessageButton').button('enable'); 
        $('#sendMessageButton').button('enable');   
    });

    $('.dismissGroupChat').on('click', function (e) { // dismiss group chat window and reset data attributes
        $('#groupMsgInput').css('height', '29px'); // reset message box height
        $('#sendGroupMessageButton').attr('data-channel-name', '');
        $('#groupMsgReader').attr('data-channel-name', '');
        $('#groupMsgReader').html('') 
    });    
});

function loadChatHistory(channel_name, targetDOM, history_type) { // get history messages
    var current_userinfo = jQuery.parseJSON(localStorage["userinfo"]);
    var current_user_id  = current_userinfo.user_info.user_id;
    var history_type = history_type;
    var messages = getMessagesFromDB(channel_name);

    plotMessages(messages, current_user_id, channel_name, targetDOM, history_type);
    //});
}; // end of history messages


function plotMessages(messages, current_user_id, channel_name, targetDOM, history_type) {

    // currently a hach 
    // for showing and hiding pagination bar
    if (messages.length >= $.pagination_size) {
        // for p2p
        $('#loadOldMessages').show();
        $('#loadOldMessages').attr('data-offset', '0');
        $('#loadOldMessagesPlaceHolder').show();
        // fix for p2p height issue
        $('#msgReader').css('height', $(window).height() - (88 + $('.headerPan').height()));
        // for group
        $('#loadOldMessagesForGroup').show();
        $('#loadOldMessagesForGroup').attr('data-offset', '0');
        $('#loadOldMessagesForGroupPlaceHolder').show();
        // fix for group height issue
        $('#groupMsgReader').css('height', $(window).height() - (88 + $('.headerPan').height()));
    }else{
        // for p2p
        $('#loadOldMessages').hide();
        $('#loadOldMessagesPlaceHolder').hide();
        // fix for p2p height issue
        $('#msgReader').css('height', $(window).height() - (52 + $('.headerPan').height()));
        // for group
        $('#loadOldMessagesForGroup').hide();
        $('#loadOldMessagesForGroupPlaceHolder').hide();
        // fix for group height issue
        $('#groupMsgReader').css('height', $(window).height() - (52 + $('.headerPan').height()));
    };

    var history_type = history_type;
    if (history_type == "p2p") {
        for (var i = 0; i < messages.length; i++) {
            try
            {
                var message_obj = messages[i];
                var icon = '';
                var unsentnote = "img/ExclamationMark.png"
                var datetime = datify(message_obj);
                console.log(message_obj)
                if (message_obj.sender) {
                    if (message_obj.sender.id == current_user_id){
                        // 
                        // chack if message contain attachment  
                        $.datetimeofp2ppreviousmessage = '';                    
                        if (message_obj.hasOwnProperty('attachment_type')) {
                            rightAttachmentChatBox(message_obj,channel_name,unsentnote,datetime,targetDOM,history_type,icon);    
                        } else {
                            rightMessageChatBox(message_obj,channel_name,unsentnote,datetime,targetDOM,history_type,icon);                               
                        }                                               
                    } else {
                        // 
                        // chack if message contain attachment                      
                        if (message_obj.hasOwnProperty('attachment_type')) {
                            leftAttachmentChatBox(message_obj,channel_name,unsentnote,datetime,targetDOM,history_type,icon);
                        } else {
                            // 
                            // if message can be merged to last message
                            leftMessageChatBox(message_obj,channel_name,unsentnote,datetime,targetDOM,history_type,icon);                                                                                                                                 
                        }
                    }
                };
            }catch(e){}
        }
    } 
    else {
        for (var i = 0; i < messages.length; i++) {
            try
            {
                var message_obj = messages[i];
                console.log(message_obj);
                var unsentnote = "img/ExclamationMark.png"
                var datetime = datify(message_obj);
                if (message_obj.sender) {
                    if (message_obj.sender.id == current_user_id){
                        // 
                        // chack if message contain attachment  
                        $.datetimeofp2ppreviousmessage = '';
                        $.previoussenderid = '';                     
                        if (message_obj.hasOwnProperty('attachment_type')) {
                            var icon ="";
                            if(message_obj.like_status == "0"){
                                 icon = "img/like-icon-grey-rev.png"
                            }else{
                                 icon = "img/like-icon-rev.png"
                            }
                            rightAttachmentChatBox(message_obj,channel_name,unsentnote,datetime,targetDOM,history_type,icon);
                        } else {
                             var icon ="";
                            if(message_obj.like_status == "0"){
                                 icon = "img/like-icon-grey-rev.png"
                            }else{
                                 icon = "img/like-icon-rev.png"
                            }
                            rightMessageChatBox(message_obj,channel_name,unsentnote,datetime,targetDOM,history_type,icon);                                                                
                        }                                               
                    } else {
                        // 
                        // chack if message contain attachment                      
                        if (message_obj.hasOwnProperty('attachment_type')) {
                            var icon ="";
                            if(message_obj.like_status == "0"){
                                 icon = "img/like-icon-grey.png"
                            }else{
                                 icon = "img/like-icon.png"
                            }
                            leftAttachmentChatBox(message_obj,channel_name,unsentnote,datetime,targetDOM,history_type,icon);
                        } else {
                            // 
                            // if message can be merged to last message
                            var icon ="";
                            if(message_obj.like_status == "0"){
                                 icon = "img/like-icon-grey.png"
                            }else{
                                 icon = "img/like-icon.png"
                            }
                            leftMessageChatBox(message_obj,channel_name,unsentnote,datetime,targetDOM,history_type,icon);   
                            $.previoussenderid = message_obj.sender.id;                                                                 
                        }
                    }
                };
            }catch(e){}
        }
    } //
    safeMessageAll(targetDOM);
    Utility.linkifyMessages(targetDOM);
    emojifyMessageAll(targetDOM); // emojify all messages
    stickerFry(targetDOM);
    $(targetDOM).animate({ scrollTop: $(targetDOM).get(0).scrollHeight }, 1500);    
};

function reloadContacts() {
    $.ajax({
        url: $.apiUrl + '/index.php/ccc/api_v1/contacts',
        beforeSend: function (xhr) {
            $.mobile.loading('show');
            xhr.setRequestHeader('token', localStorage["session_token"]);
        },
        success: function (json) {
            localStorage.hris_enterprise_chat_contacts  = JSON.stringify(json.people);
            localStorage.hris_enterprise_chat_roles     = JSON.stringify(json.roles);
            localStorage.hris_enterprise_chat_groups    = JSON.stringify(json.groups);
            window.location.replace('messenger.html');
        },
        error: function (json) {
            alert('Error fetching updated contact list from server.')
        },
        complete: function(jqXHR, textStatus) { 
            $.mobile.loading('hide'); 
        }
    });
};