$().ready(function(){
	// 
	// p2p chats ---------------------------------------------------------------------
	$('#p2pOptionsTogeller').on('click', function(e){
		vibrate($.vibrateduration)
		$('#p2pOptions').slideToggle('fast',function(){
			$('#p2pOptionsTab').find('li[data-tab-class=smile-tab]').trigger('click');
		});
		if($(this).attr('src') == 'img/add-icon.png') {
			$(this).attr('src','img/down-icon.png');
		}
		else {
			$(this).attr('src','img/add-icon.png');
		}
	});

	$('.emoji-list-icon').on('click', function(e){
		var smile_code = $(this).attr('data-emoji-code');
		$('#msgInput').insertAtCaret(smile_code);
	});

	// Hide on outside click
    $(document).click(function(e){
        if( $(e.target).is('#p2pOptionsTogeller') || $(e.target).closest('#p2pOptionsTogeller').length) {
            console.log('A')
        } else {
            if( $(e.target).is('#p2pOptions') || $(e.target).closest('#p2pOptions').length) {
                console.log('I')
            }
            else {
                $("#p2pOptions").slideUp(); 
                $('#p2pOptionsTogeller').attr('src','img/add-icon.png');
            }
        }
    });	  

    // options tab selection
	var prevSelection = "smile-tab";
	$("#p2pOptionsTab ul li").on("click",function(){
		$("#p2pOptionsTab ul li").removeClass("active");
		$(this).addClass("active");

	    var newSelection = $(this).attr("data-tab-class");
	    $("."+prevSelection).addClass("ui-screen-hidden");
	    $("."+newSelection).removeClass("ui-screen-hidden");
	    prevSelection = newSelection;
	});    

    // 
    // group and role chat -------------------------------------------------------------
	$('#groupOptionsTogeller').on('click', function(e){
		vibrate($.vibrateduration)
		$('#groupOptions').slideToggle('fast',function(){
			$('#groupOptionsTab').find('li[data-tab-class=smile-tab]').trigger('click');
		});
		if($(this).attr('src') == 'img/add-icon.png') {
			$(this).attr('src','img/down-icon.png');
		}
		else {
			$(this).attr('src','img/add-icon.png');
		}
		
	});	

	$('.emoji-list-group-icon').on('click', function(e){
		var smile_code = $(this).attr('data-emoji-code');
		$('#groupMsgInput').insertAtCaret(smile_code);
	});

	// Hide on outside click
    $(document).click(function(e){
        if( $(e.target).is('#groupOptionsTogeller')|| $(e.target).closest('#groupOptionsTogeller').length) {
            console.log('A')
        }
        else {
            if( $(e.target).is('#groupOptions')|| $(e.target).closest('#groupOptions').length) {
                console.log('I')
            }
            else {
                $("#groupOptions").slideUp('fast')
                $('#groupOptionsTogeller').attr('src','img/add-icon.png');
            }
        }
    }); 

	$("#groupOptionsTab ul li").on("click",function(){
		$("#groupOptionsTab ul li").removeClass("active");
		$(this).addClass("active");

	    var newSelection = $(this).attr("data-tab-class");
	    $("."+prevSelection).addClass("ui-screen-hidden");
	    $("."+newSelection).removeClass("ui-screen-hidden");
	    prevSelection = newSelection;
	});        

});

// 
// function for font style selector
$().ready(function(){
  $('.font-style-selector').on('click', function(e){
    if ($(this).attr('rel') == "none") {
        localStorage.removeItem("chat_font_style");
        $('.font-style-selector').removeClass('selectedFontStyle');
        $('.font-style-selector[rel="none"]').hide();
        $('.font-style-selector[rel="none"]').closest('li').siblings().removeClass('active');
    }else{
        localStorage.setItem("chat_font_style", $(this).attr('rel'));
        $('.font-style-selector').removeClass('selectedFontStyle');
        $('.font-style-selector[rel="'+ $(this).attr('rel') +'"]').closest('li').addClass('active');
        $('.font-style-selector[rel="'+ $(this).attr('rel') +'"]').closest('li').siblings().removeClass('active');
        $('.font-style-selector[rel="'+ $(this).attr('rel') +'"]').addClass('selectedFontStyle');
        $('.font-style-selector[rel="none"]').show();
    };
  });
});

// emojify messages
// emoji.init_env();

function emojifyMessageAll(targetDOM){
	var auto_mode = emoji.replace_mode;
	var message_doms = $(targetDOM + ' .message');
	$.each( message_doms, function() {
		var text = $(this).html();
		emoji.replace_mode = auto_mode;
		var out = emoji.replace_colons(text);
		
		$(this).html(out);
	});
}

function safeMessageAll(targetDOM){
	var message_doms = $(targetDOM + ' .message');
	$.each( message_doms, function() {
			var text = $(this).text();
			var out = text.toString().deentitize();
			$(this).text(out);
	});
}

function safeMessage(message_dom){
		var text = message_dom.text();
		var out = text.toString().deentitize();
		message_dom.text(out);
}

function emojifyMessage(message_dom){
	var auto_mode = emoji.replace_mode;
	var text = message_dom.html();
	emoji.replace_mode = auto_mode;
	var out = emoji.replace_colons(text);
	
	message_dom.html(out);
}

function emojifySmilesList(dom){
	var auto_mode = emoji.replace_mode;
	var icon_doms = dom;
	$.each( icon_doms, function() {
		var text = $(this).text();
		emoji.replace_mode = auto_mode;
		var out = emoji.replace_colons(text);

		$(this).html(out);
	});
}

// Hide silently after attachment post to p2p
function hideOptionsP2p(){
	$('#p2pOptions').hide();
	$('#p2pOptionsTogeller').attr('src','img/add-icon.png');
}  

// Hide silently after attachment post to group
function hideOptionsGroup(){
	$('#groupOptions').hide();
	$('#groupOptionsTogeller').attr('src','img/add-icon.png');
}  