var db = Ti.Database.open('socialfire');
var saveMessageToDB = function (message_obj) {

    message_id = parseInt(message_obj.message_id);
    if (typeof message_obj.receiver == "undefined") {
        receiver_id = "undefined"
        receiver_name = "undefined"
        receiver_photo = "undefined"
    } else {
        receiver_id = message_obj.receiver.id
        receiver_name = message_obj.receiver.name
        receiver_photo = message_obj.receiver.photo
    }

    if (typeof message_obj.group == "undefined") {
        group_id = "undefined"
        group_name = "undefined"
    } else {
        group_id = message_obj.group.id;
        group_name = message_obj.group.name;
    }

    if (typeof message_obj.role == "undefined") {
        role_id = "undefined"
        role_name = "undefined"
    } else {
        role_id = message_obj.role.id;
        role_name = message_obj.role.name;
    }
    var like_count;
    var like_status;
    var is_liking;
    if (typeof message_obj.like_count != "undefined") {
        like_count = parseInt(message_obj.like_count).toString();
    } else {
        like_count = message_obj.like_count
    }
    if (typeof message_obj.like_status != "undefined") {
        like_status = parseInt(message_obj.like_status).toString();
    } else {
        like_status = message_obj.like_status
    }
    if (typeof message_obj.is_liking != "undefined") {
        is_liking = parseInt(message_obj.is_liking).toString();
    } else {
        is_liking = message_obj.like_status
    }
	
	var allowed_suborg_ids
	if (typeof message_obj.allowed_suborg_ids != "undefined") {
		allowed_suborg_ids = message_obj.allowed_suborg_ids.toString()
	}else{
		allowed_suborg_ids = "undefined"
	};
    
    //db.transaction(function (tx) {
        db.execute("DELETE from socialfire where message_client_id=?",message_obj.message_client_id);
        db.execute('INSERT INTO socialfire (message ,message_id,message_client_id ,date ,merge_to_last_message ,textformat ,time ,attachment_type ,attachment_url ,channel_name ,sender_id ,sender_name ,sender_photo ,receiver_id ,receiver_name ,receiver_photo ,video_image, group_id, group_name, role_id, role_name, like_count, like_status, is_liking, allowed_suborg_ids ) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)', message_obj.message, message_id, message_obj.message_client_id, message_obj.date, message_obj.merge_to_last_message, message_obj.textformat, message_obj.time, message_obj.attachment_type, message_obj.attachment_url, message_obj.channel_name, message_obj.sender.id, message_obj.sender.name, message_obj.sender.photo, receiver_id, receiver_name, receiver_photo, message_obj.video_image, group_id, group_name, role_id, role_name, like_count, like_status, is_liking, allowed_suborg_ids);
   // }, errorCB, successCB);
}

    function getMessagesFromDB(channel_name) {
        var msg_obj = [];
            var resultSet = db.execute('SELECT * FROM socialfire where socialfire.channel_name=? order by socialfire.id DESC LIMIT ?;', channel_name, $.pagination_size);
                
                        while (resultSet.isValidRow()) {
                            var single_msg_obj;
                                if (resultSet.fieldByName('attachment_type').toString() == "1") {
                                    single_msg_obj = {
                                        "sender": {
                                            "id": resultSet.fieldByName('sender_id'),
                                            "name": resultSet.fieldByName('sender_name'),
                                            "photo": resultSet.fieldByName('sender_photo')
                                        },
                                        "receiver": {
                                            "id": resultSet.fieldByName('receiver_id'),
                                            "name": resultSet.fieldByName('receiver_name'),
                                            "photo": resultSet.fieldByName('receiver_photo')
                                        },
                                        "message_id": resultSet.fieldByName('message_id'),
                                        "channel_name": resultSet.fieldByName('channel_name'),
                                        "message": resultSet.fieldByName('message'),
                                        "date": resultSet.fieldByName('date'),
                                        "message_client_id": resultSet.fieldByName('message_client_id'),
                                        "time": resultSet.fieldByName('time'),
                                        "merge_to_last_message": resultSet.fieldByName('merge_to_last_message'),
                                        "textformat": resultSet.fieldByName('textformat'),
                                        "allowed_suborg_ids": resultSet.fieldByName('allowed_suborg_ids'),
                                        "group": {
                                            "id": resultSet.fieldByName('group_id'),
                                            "name": resultSet.fieldByName('group_name')
                                        },
                                        "role": {
                                            "id": resultSet.fieldByName('role_id'),
                                            "name": resultSet.fieldByName('role_name')
                                        },
                                        "like_count": resultSet.fieldByName('like_count'),
                                        "like_status": resultSet.fieldByName('like_status'),
                                        "is_liking": resultSet.fieldByName('is_liking')
                                    }
                                } else {
                                    single_msg_obj = {
                                        "sender": {
                                            "id": resultSet.fieldByName('sender_id'),
                                            "name": resultSet.fieldByName('sender_name'),
                                            "photo": resultSet.fieldByName('sender_photo')
                                        },
                                        "receiver": {
                                            "id": resultSet.fieldByName('receiver_id'),
                                            "name": resultSet.fieldByName('receiver_name'),
                                            "photo": resultSet.fieldByName('receiver_photo')
                                        },
                                        "message_id": resultSet.fieldByName('message_id'),
                                        "channel_name": resultSet.fieldByName('channel_name'),
                                        "message": resultSet.fieldByName('message'),
                                        "date": resultSet.fieldByName('date'),
                                        "message_client_id": resultSet.fieldByName('message_client_id'),
                                        "time": resultSet.fieldByName('time'),
                                        "merge_to_last_message": resultSet.fieldByName('merge_to_last_message'),
                                        "textformat": resultSet.fieldByName('textformat'),
                                        "attachment_type": resultSet.fieldByName('attachment_type'),
                                        "attachment_url": resultSet.fieldByName('attachment_url'),
                                        "channel_event": "message",
                                        "video_image": resultSet.fieldByName('video_image'),
                                        "allowed_suborg_ids": resultSet.fieldByName('allowed_suborg_ids'),
                                        "group": {
                                            "id": resultSet.fieldByName('group_id'),
                                            "name": resultSet.fieldByName('group_name')
                                        },
                                        "role": {
                                            "id": resultSet.fieldByName('role_id'),
                                            "name": resultSet.fieldByName('role_name')
                                        },
                                        "like_count": resultSet.fieldByName('like_count'),
                                        "like_status": resultSet.fieldByName('like_status'),
                                        "is_liking": resultSet.fieldByName('is_liking')
                                    }
                                }

                            msg_obj.push(single_msg_obj);
                            resultSet.next();
                        }
                        resultSet.close();
                        return msg_obj.reverse();
    }

    function getLastSavedMessageFromDB(all_channels) {
        var msg_obj = [];
        var channel_object = new Object();
        var localdata = [];
        //db.transaction(function (transaction) {
            var q = 'SELECT * FROM socialfire where socialfire.channel_name=? and socialfire.message_id != ?  order by  socialfire.message_id desc LIMIT 1';
            $.each(all_channels, function (index, channel_name) {
                var resultSet = db.execute(q, channel_name, "");
                //function (transaction, result) {
                    if (resultSet.rowCount() > 0) {
                        while (resultSet.isValidRow()) {
                            var message_id = resultSet.fieldByName('message_id');
                            if (typeof message_id == "1") {
                                localdata.push({
                                    "channel_name": channel_name,
                                    "last_saved_message_id": ""
                                });
                            } else {
                                localdata.push({
                                    "channel_name": channel_name,
                                    "last_saved_message_id": message_id
                                });
                            }
                            resultSet.next();
                        }
                        resultSet.close();
                    } else {
                        localdata.push({
                            "channel_name": channel_name,
                            "last_saved_message_id": ""
                        });
                    }                   
            });   
            channel_object.channel_details = localdata
            return(channel_object);
    }

        var saveLatestMessageToDB = function (messages) {
            //db.transaction(function (tx) {
                var q = 'INSERT INTO socialfire (message ,message_id,message_client_id ,date ,merge_to_last_message ,textformat ,time ,attachment_type ,attachment_url ,channel_name ,sender_id ,sender_name ,sender_photo ,receiver_id ,receiver_name ,receiver_photo ,video_image, group_id, group_name, role_id, role_name, like_count, like_status, is_liking, allowed_suborg_ids ) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)';
                $.each(messages, function (index, message) {
                    message_id = parseInt(message.message_id);
                    if (typeof message.receiver == "undefined") {
                        receiver_id = "undefined"
                        receiver_name = "undefined"
                        receiver_photo = "undefined"
                    } else {
                        receiver_id = message.receiver.id
                        receiver_name = message.receiver.name
                        receiver_photo = message.receiver.photo
                    }

                    if (typeof message.group == "undefined") {
                        group_id = "undefined"
                        group_name = "undefined"
                    } else {
                        group_id = message.group.id;
                        group_name = message.group.name;
                    }

                    if (typeof message.role == "undefined") {
                        role_id = "undefined"
                        role_name = "undefined"
                    } else {
                        role_id = message.role.id;
                        role_name = message.role.name;
                    }
                    var like_count;
                    var like_status;
                    var is_liking;
                    if (typeof message.like_count != "undefined") {

                        like_count = parseInt(message.like_count).toString();

                    }else{
                        like_count = "0"                        
                    }
                    if (typeof message.like_status != "undefined") {
                        like_status = parseInt(message.like_status).toString();
                    }else{
                        like_status = "0"
                    }
                    if (typeof message.is_liking != "undefined") {
                        is_liking = parseInt(message.is_liking).toString();
                    }else{
                        is_liking = "0"
                    }
                    if(typeof message.allowed_suborg_ids != "undefined"){
                        allowed_suborg_ids = message.allowed_suborg_ids.toString()
                    }else{
                        allowed_suborg_ids = ""
                    }
                    console.log(message.sender.id)
                    db.execute(q, message.message, message_id, message.message_client_id, message.date, message.merge_to_last_message, message.textformat, message.time, message.attachment_type, message.attachment_url, message.channel_name, message.sender.id, message.sender.name, message.sender.photo, receiver_id, receiver_name, receiver_photo, message.video_image, group_id, group_name, role_id, role_name, like_count, like_status, is_liking, allowed_suborg_ids);
                    if(index == messages.length - 1){
                        window.location.replace('messenger.html');
                    }
                });
            //}, errorCB, successCB);
        }

        function clearLocalData(){
            db.execute("DELETE from socialfire");
            db.execute('delete from sqlite_sequence where name=?', 'socialfire');
        }

            function updatelikestatus(message) {
                var like_count;
                var like_status;
                var is_liking;
                var current_userinfo = jQuery.parseJSON(localStorage["userinfo"]);
                var current_user_id  = current_userinfo.user_info.user_id;
                if (typeof message.message.like_count != "undefined") {
                    like_count = parseInt(message.message.like_count).toString();
                }
                if (typeof message.message.like_status != "undefined") {
                    if(message.message.sender_id == current_user_id){
                        like_status = parseInt(message.message.like_status).toString();   
                    }else{
                        like_status = "0"
                    }
                }
                if (typeof message.message.is_liking != "undefined") {
                    is_liking = parseInt(message.message.is_liking).toString();
                }

               // db.transaction(function (transaction) {
                if(message.message.sender_id == current_user_id){
                    db.execute('UPDATE socialfire SET like_count=? , like_status=?,is_liking=? where message_id=?;', like_count, like_status, is_liking, message.message.id);
                }else{
                    db.execute('UPDATE socialfire SET like_count=? , is_liking=? where message_id=?;', like_count,  is_liking, message.message.id);
                }
            }

            function errorPreparingMessageObject() {
                alert('Error populating message list objects.');
            }

            // Transaction error callback
            //
            function errorCB(tx) {
                alert("Error processing SQL: "+ tx.message);
            }

            // Transaction success callback
            //
            function successCB() {

            }