$(document).ready(function(){
    $("#groupattachmentToggler").click(function(){
        $(".groupattachPan").toggle("bounce", { times: 3 }, "slow"); 
    });
});

// Called when capture operation is finished
    //
function groupcaptureSuccess(mediaFiles) {
    var i, len;

    for (i = 0, len = mediaFiles.length; i < len; i += 1) {
        console.log("bbbbb" + mediaFiles[i])
        grouponVideoURISuccess(mediaFiles[i]);
    }       
}

// Called when capture operation is finished
    //
function groupcaptureaudioSuccess(mediaFiles) {
    /*var i, len;

    for (i = 0, len = mediaFiles.length; i < len; i += 1) {
        console.log("bbbbb" + mediaFiles[i])
        grouponAudioURISuccess(mediaFiles[i]);
    }  */ 

}

// Called if something bad happens.
// 
function groupcaptureError(error) {
    var msg = 'An error occurred during capture: ' + error.code;
    alert(msg, null, 'Error!');
}

// Called if something bad happens.
// 
function groupcaptureaudioError(error) {
    var msg = 'An error occurred during capture: ' + error.code;
    alert(msg, null, 'Error!');
}
// Called when a Video is successfully retrieved
//
function grouponVideoURISuccess(videofile) {
    var sender_id = $('#sendGroupMessageButton').attr('data-sender-id');
    var message_client_id = (sender_id+'_'+($.now()));
    console.log("aaaa" + videofile.fullPath);
    $('#groupMsgReader').append( // sender append chat message
        '<div  class="fRight mLeft8 chatRight" id="'+ message_client_id +'"><span class="chatRightArrow"><img src="img/chat-right.gif" alt="" /></span><img src="img/play.png" onclick="openVideo('+ "'" + videofile.fullPath + "'" +')"  width="30" style="position:absolute;left: 42px;top:26px;"/><img class="attachment-image-message" onclick="openVideo('+ "'" + videofile.fullPath + "'" +')"  style="height:65px;width=100px" width="100" height="65" src="img/video-icon.png" /><p class="date"><span><img src="img/schedule-clock.png" width="9"/></span></p></div><div class="clear"></div>'
    );
    // 
    // hide group chat options
    hideOptionsGroup()
    // scroll top slowly
    $('#groupMsgReader').animate({ scrollTop: $('#groupMsgReader').get(0).scrollHeight }, 1500);

    // Upload the image to server using FileTransfer
    // 
    var options = new FileUploadOptions();
    options.fileKey     = "file";
    options.fileName    = videofile.name
    options.mimeType = "video/mp4";
    options.headers = {
        Connection: "close"
    }
    options.chunkedMode = false;
    var ft = new FileTransfer();
    ft.upload(
        videofile.fullPath, 
        encodeURI($.apiUrl + "/ccc/file_upload"), 
        function(r) {
            var video_url = r.response.replace(/[\n]/g, "");
            groupuploadVideo(video_url, message_client_id);
        },
        function(error) {
            // alert("An error has occurred: Code = " + error.code);
            // console.log("upload error source " + error.source);
            // console.log("upload error target " + error.target);
            alert("An error has occurred");
            //$('#'+message_client_id).remove();
        }, 
        options
    );

}


// Called when a Audio is successfully retrieved
//
function grouponAudioURISuccess(audiofile) {
    var sender_id = $('#sendGroupMessageButton').attr('data-sender-id');
    var message_client_id = (sender_id+'_'+($.now()));
    console.log("aaaa" + audiofile.fullPath);
    $('#groupMsgReader').append( // sender append chat message
        '<div  class="fRight mLeft8 chatRight" id="'+ message_client_id +'"><span class="chatRightArrow"><img src="img/chat-right.gif" alt="" /></span><img class="attachment-image-message positioncenter"  onclick="openAudio('+ "'" + audiofile.fullPath + "'" +')"  style="width: 32px; height: 32px;" src="img/audio-icon.gif" /><p class="date"><span><img src="img/schedule-clock.png" width="9"/></span></p></div><div class="clear"></div>'
    );
    // 
    // hide group chat options
    hideOptionsGroup();
    // scroll top slowly
    $('#groupMsgReader').animate({ scrollTop: $('#groupMsgReader').get(0).scrollHeight }, 1500);

    // Upload the image to server using FileTransfer
    // 
    var options = new FileUploadOptions();
    options.fileKey     = "file";
    options.fileName    = audiofile.name
    options.mimeType = "audio/mp3";
    options.headers = {
        Connection: "close"
    }
    options.chunkedMode = false;
    var ft = new FileTransfer();
    ft.upload(
        audiofile.fullPath, 
        encodeURI($.apiUrl + "/ccc/file_upload"), 
        function(r) {
            var audio_url = r.response.replace(/[\n]/g, "");
            groupuploadAudio(audio_url, message_client_id);
        },
        function(error) {
            // alert("An error has occurred: Code = " + error.code);
            // console.log("upload error source " + error.source);
            // console.log("upload error target " + error.target);
            alert("An error has occurred");
            //$('#'+message_client_id).remove();
        }, 
        options
    );

}

// Called when a photo is successfully retrieved
//
function grouponPhotoURISuccess(imageURI) {
    var sender_id = $('#sendGroupMessageButton').attr('data-sender-id');
    var message_client_id = (sender_id+'_'+($.now()));

    $('#groupMsgReader').append( // sender append chat message
        '<div  class="fRight mLeft8 chatRight" id="'+ message_client_id +'"><span class="chatRightArrow"><img src="img/chat-right.gif" alt="" /></span><img class="attachment-image-message" onclick="openImage(' + "'" + imageURI.toString() + "'" +')" style="height:30%" src="'+imageURI+'" /><p class="date"><span><img src="img/schedule-clock.png" width="9"/></span></p></div><div class="clear"></div>'
    );
    // 
    // hide group chat options
    hideOptionsGroup();
    // scroll top slowly
    $('#groupMsgReader').animate({ scrollTop: $('#groupMsgReader').get(0).scrollHeight }, 1500);

    // Upload the image to server using FileTransfer
    // 
    var options = new FileUploadOptions();
    options.fileKey     = "file";
    options.fileName    = imageURI.substr(imageURI.lastIndexOf('/')+1);
    options.mimeType    = "image/jpeg";
    options.headers = {
        Connection: "close"
    }
    options.chunkedMode = false;
    var ft = new FileTransfer();
    ft.upload(
        imageURI, 
        encodeURI($.apiUrl + "/ccc/file_upload"), 
        function(r) {
            var image_url = r.response.replace(/[\n]/g, "");
            groupuploadPhoto(image_url, message_client_id);
        },
        function(error) {
            // alert("An error has occurred: Code = " + error.code);
            // console.log("upload error source " + error.source);
            // console.log("upload error target " + error.target);
            alert("An error has occurred");
            //$('#'+message_client_id).remove();
        }, 
        options
    );

}

// Called when a galary video is successfully retrieved
//
function groupongallaryVideoURISuccess(videoURI) {
    var sender_id = $('#sendGroupMessageButton').attr('data-sender-id');
    var message_client_id = (sender_id+'_'+($.now()));

    $('#groupMsgReader').append( // sender append chat message
        '<div  class="fRight mLeft8 chatRight" id="'+ message_client_id +'"><span class="chatRightArrow"><img src="img/chat-right.gif" alt="" /></span><img src="img/play.png" onclick="openVideo('+ "'" + videoURI.toString() + "'" +')" width="30" style="position:absolute;left: 42px;top:26px;"/><img class="attachment-image-message" onclick="openVideo('+ "'" + videoURI.toString() + "'" +')"  style="height:65px;width: 100px" width="100" height="65" src="img/video-icon.png" /><p class="date"><span><img src="img/schedule-clock.png" width="9"/></span></p></div><div class="clear"></div>'
    );
    // 
    // hide group chat options
    hideOptionsGroup();
    // scroll top slowly
    $('#groupMsgReader').animate({ scrollTop: $('#groupMsgReader').get(0).scrollHeight }, 1500);

    // Upload the video to server using FileTransfer
    // 
    var options = new FileUploadOptions();
    options.fileKey     = "file";
    options.fileName    = videoURI.substr(videoURI.lastIndexOf('/')+1);
    options.mimeType    = "video/mp4";
    options.headers = {
        Connection: "close"
    }
    options.chunkedMode = false;
    var ft = new FileTransfer();
    ft.upload(
        videoURI, 
        encodeURI($.apiUrl + "/ccc/file_upload"), 
        function(r) {
            var video_url = r.response.replace(/[\n]/g, "");
            groupuploadVideo(video_url, message_client_id);
        },
        function(error) {
            // alert("An error has occurred: Code = " + error.code);
            // console.log("upload error source " + error.source);
            // console.log("upload error target " + error.target);
            alert("An error has occurred");
            //$('#'+message_client_id).remove();
        }, 
        options
    );

}

// Called when a galary file is successfully retrieved
//
function groupongallaryFileURISuccess(fileURI) {
    var sender_id = $('#sendGroupMessageButton').attr('data-sender-id');
    var message_client_id = (sender_id+'_'+($.now()));

    $('#groupMsgReader').append( // sender append chat message
        '<div class="fRight mLeft8 chatRight" id="'+ message_client_id +'"><span class="chatRightArrow"><img src="img/chat-right.gif" alt="" /></span><img onclick="openremoteFile('+ "'" + fileURI.toString() + "'" +')" class="attachment-image-message positioncenter" style="height:32px;width: 32px" width="32" height="32" src="img/file-icon.png" /><p class="date"><span><img src="img/schedule-clock.png" width="9"/></span></p></div><div class="clear"></div>'
    );
    // 
    // hide group chat options
    hideOptionsGroup();
    // scroll top slowly
    $('#groupMsgReader').animate({ scrollTop: $('#groupMsgReader').get(0).scrollHeight }, 1500);

    // Upload the video to server using FileTransfer
    // 
    var options = new FileUploadOptions();
    options.fileKey     = "file";
    options.fileName    = fileURI.substr(fileURI.lastIndexOf('/')+1);
    options.mimeType    = "";
    options.headers = {
        Connection: "close"
    }
    options.chunkedMode = false;
    var ft = new FileTransfer();
    ft.upload(
        fileURI, 
        encodeURI($.apiUrl + "/ccc/file_upload"), 
        function(r) {
            var file_url = r.response.replace(/[\n]/g, "");
            groupuploadFile(file_url, message_client_id);
        },
        function(error) {
            // alert("An error has occurred: Code = " + error.code);
            // console.log("upload error source " + error.source);
            // console.log("upload error target " + error.target);
            alert("An error has occurred");
            //$('#'+message_client_id).remove();
        }, 
        options
    );

}
// Finally upload it to the server.
// 
function groupuploadPhoto(image_url, message_client_id) {
    var session_token = localStorage["session_token"]
    var channel_name = $('#sendGroupMessageButton').attr('data-channel-name');
    var group_id = $('#sendGroupMessageButton').attr('data-group-id');   
    var chat_type =   $('#sendGroupMessageButton').attr('data-chat-type');   
    if(chat_type.toString() == "group"){
            console.log(image_url)
            console.log(group_id)
            console.log(channel_name)
            console.log(message_client_id)

            $.ajax({
                url: $.apiUrl + "/ccc/api_v1/message_attachment_group",
                type: "POST",
                data: {
                    attachment: image_url,
                    attachment_type: 'image',
                    group_id: group_id,
                    channel_name: channel_name,
                    channel_event: 'attachment-message',
                    message_client_id: message_client_id
                },
                beforeSend: function(xhr) { 
                    xhr.setRequestHeader('token', session_token);
                },
                success: function(json){console.log(json) },
                error: function (xhr, ajaxOptions, thrownError) {
                    alert(xhr.status);
                    alert(thrownError);
                    console.log(xhr);
                    //$('#'+message_client_id).remove();
                }
        });
    }else{
        $.ajax({
                url: $.apiUrl + "/ccc/api_v1/message_attachment_role",
                type: "POST",
                data: {
                    attachment: image_url,
                    attachment_type: 'image',
                    role_id: group_id,
                    channel_name: channel_name,
                    channel_event: 'attachment-message',
                    message_client_id: message_client_id
                },
                beforeSend: function(xhr) { 
                    xhr.setRequestHeader('token', session_token);
                },
                success: function(json){console.log(json) },
                error: function (xhr, ajaxOptions, thrownError) {
                    alert(xhr.status);
                    alert(thrownError);
                    console.log(xhr);
                    //$('#'+message_client_id).remove();
                }
        });
    }
}

// Finally upload it to the server.
// 
function groupuploadVideo(video_url, message_client_id) {
    var session_token = localStorage["session_token"]
    var channel_name = $('#sendGroupMessageButton').attr('data-channel-name');
    var group_id = $('#sendGroupMessageButton').attr('data-group-id');
    var chat_type =   $('#sendGroupMessageButton').attr('data-chat-type');
    if(chat_type.toString() == "group"){  
        $.ajax({
            url: $.apiUrl + "/ccc/api_v1/message_attachment_group",
            type: "POST",
            data: {
                attachment: video_url,
                attachment_type: 'video',
                group_id: group_id,
                channel_name: channel_name,
                channel_event: 'attachment-message',
                message_client_id: message_client_id
            },
            beforeSend: function(xhr) { 
                xhr.setRequestHeader('token', session_token);
            },
            success: function(json){console.log(json) },
            error: function (xhr, ajaxOptions, thrownError) {
                alert(xhr.status);
                alert(thrownError);
                //$('#'+message_client_id).remove();
            }
        });
    }else{
        console.log(video_url);
        $.ajax({
            url: $.apiUrl + "/ccc/api_v1/message_attachment_role",
            type: "POST",
            data: {
                attachment: video_url,
                attachment_type: 'video',
                role_id: group_id,
                channel_name: channel_name,
                channel_event: 'attachment-message',
                message_client_id: message_client_id
            },
            beforeSend: function(xhr) { 
                xhr.setRequestHeader('token', session_token);
            },
            success: function(json){console.log(json) },
            error: function (xhr, ajaxOptions, thrownError) {
                alert(xhr.status);
                alert(thrownError);
                //$('#'+message_client_id).remove();
            }
        });
    }
}


// Finally upload it to the server.
// 
function groupuploadFile(file_url, message_client_id) {
    var session_token = localStorage["session_token"]
    var channel_name = $('#sendGroupMessageButton').attr('data-channel-name');
    var group_id = $('#sendGroupMessageButton').attr('data-group-id');
    var chat_type =   $('#sendGroupMessageButton').attr('data-chat-type');
    if(chat_type.toString() == "group"){  
        $.ajax({
            url: $.apiUrl + "/ccc/api_v1/message_attachment_group",
            type: "POST",
            data: {
                attachment: file_url,
                attachment_type: 'file',
                group_id: group_id,
                channel_name: channel_name,
                channel_event: 'attachment-message',
                message_client_id: message_client_id
            },
            beforeSend: function(xhr) { 
                xhr.setRequestHeader('token', session_token);
            },
            success: function(json){console.log(json) },
            error: function (xhr, ajaxOptions, thrownError) {
                alert(xhr.status);
                alert(thrownError);
                //$('#'+message_client_id).remove();
            }
        });
    }else{
        $.ajax({
            url: $.apiUrl + "/ccc/api_v1/message_attachment_role",
            type: "POST",
            data: {
                attachment: file_url,
                attachment_type: 'file',
                role_id: group_id,
                channel_name: channel_name,
                channel_event: 'attachment-message',
                message_client_id: message_client_id
            },
            beforeSend: function(xhr) { 
                xhr.setRequestHeader('token', session_token);
            },
            success: function(json){console.log(json) },
            error: function (xhr, ajaxOptions, thrownError) {
                alert(xhr.status);
                alert(thrownError);
                //$('#'+message_client_id).remove();
            }
        });
    }
}


// Finally upload it to the server.
// 
function groupuploadAudio(audio_url, message_client_id) {
    var session_token = localStorage["session_token"]
    var channel_name = $('#sendGroupMessageButton').attr('data-channel-name');
    var group_id = $('#sendGroupMessageButton').attr('data-group-id');
    var chat_type =   $('#sendGroupMessageButton').attr('data-chat-type');
    if(chat_type.toString() == "group"){  
        $.ajax({
            url: $.apiUrl + "/ccc/api_v1/message_attachment_group",
            type: "POST",
            data: {
                attachment: audio_url,
                attachment_type: 'audio',
                group_id: group_id,
                channel_name: channel_name,
                channel_event: 'attachment-message',
                message_client_id: message_client_id
            },
            beforeSend: function(xhr) { 
                xhr.setRequestHeader('token', session_token);
            },
            success: function(json){console.log(json) },
            error: function (xhr, ajaxOptions, thrownError) {
                alert(xhr.status);
                alert(thrownError);
                //$('#'+message_client_id).remove();
            }
        });
    }else{
        $.ajax({
            url: $.apiUrl + "/ccc/api_v1/message_attachment_role",
            type: "POST",
            data: {
                attachment: audio_url,
                attachment_type: 'audio',
                role_id: group_id,
                channel_name: channel_name,
                channel_event: 'attachment-message',
                message_client_id: message_client_id
            },
            beforeSend: function(xhr) { 
                xhr.setRequestHeader('token', session_token);
            },
            success: function(json){console.log(json) },
            error: function (xhr, ajaxOptions, thrownError) {
                alert(xhr.status);
                alert(thrownError);
                //$('#'+message_client_id).remove();
            }
        });
    }
}


// Called if something bad happens.
//
function grouponFail(message) {
    alert('Failed because: ' + message);
}

// A button will call this function
//
function groupcapturePhoto() {
    // Take picture using device camera and retrieve image as base64-encoded string
    navigator.camera.getPicture(grouponPhotoURISuccess, grouponFail, 
        { 
            quality: 50,
            destinationType: navigator.camera.DestinationType.FILE_URL,
            sourceType: navigator.camera.PictureSourceType.CAMERA,
            correctOrientation: true,
            saveToPhotoAlbum: true,
            targetWidth: 800,
            targetHeight: 600
        }
    );
}

// A button will call this function
//
function groupgetPhoto() {
    // Retrieve image file location from specified source
    /*navigator.camera.getPicture(grouponPhotoURISuccess, grouponFail, 
        { 
            quality: 50, 
            destinationType: navigator.camera.DestinationType.FILE_URL,
            sourceType: navigator.camera.PictureSourceType.PHOTOLIBRARY 
        }
    );*/
            var options = {
                title : "Select image file...",
                types : window.imagetypes,
                typesDescription : "Image files",
                path : "/"
            };

            var curwin = Ti.UI.currentWindow; 
            curwin.openFileChooserDialog( function(fileResponse) { 
                var file = Ti.Filesystem.getFile(fileResponse[0]); 
                desktopgroupUploadImage(file);
            },options);
            hideOptionsGroup();
}

var desktopgroupUploadImage = function(file){
            console.log("FILE");
            console.log(file);
            
            var uploadStream = Ti.Filesystem.getFileStream(file);
        
            uploadStream.open(Ti.Filesystem.MODE_READ);
            content = uploadStream.read();
            uploadStream.close();
        
            console.log("CONTENT");
            console.log(content);
            var sender_id = $('#sendGroupMessageButton').attr('data-sender-id');
            var message_client_id = (sender_id+'_'+($.now()));
            local_file = "file:///" + file.toString();
            $('#groupMsgReader').append( // sender append chat message
                '<div  class="fRight mLeft8 chatRight" id="'+ message_client_id +'"><span class="chatRightArrow"><img src="img/chat-right.gif" alt="" /></span><img class="attachment-image-message" onclick="openImage(' + "'" + local_file + "'" +')" style="height:30%" src="'+local_file+'" /><p class="date"><span><img src="img/schedule-clock.png" width="9"/></span></p></div><div class="clear"></div>'
            );
            // 
            // hide group chat options
            hideOptionsGroup();
            // scroll top slowly
            $('#groupMsgReader').animate({ scrollTop: $('#groupMsgReader').get(0).scrollHeight }, 1500);


                var channel_name = $('#sendGroupMessageButton').attr('data-channel-name');  
                var chat_type =   $('#sendGroupMessageButton').attr('data-chat-type'); 
                var group_id = "undefined";
                var role_id = "undefined";
                if(chat_type.toString() == "group"){
                    group_id = parseInt(channel_name);
                }else{
                    role_id = parseInt(channel_name);    
                }
                current_msg_obj = {
                            "sender": {
                                "id": sender_id,
                                "name": '',
                                "photo": ''
                            },
                            "receiver": {
                                "id": '',
                                "name": '',
                                "photo": ''
                            },
                            "message_id": $.now(),
                            "channel_name": channel_name,
                            "message": '',
                            "date": '',
                            "message_client_id": message_client_id,
                            "time": '',
                            "merge_to_last_message": 'false',
                            "textformat": '',
                            "attachment_type": 'image',
                            "attachment_url": local_file,
                            "channel_event": "message",
                            "video_image": '',
                            "allowed_suborg_ids": '',
                            "group": {
                                "id": group_id,
                                "name": ''
                            },
                            "role": {
                                "id": role_id,
                                "name": ''
                            },
                            "like_count": '0',
                            "like_status": '0',
                            "is_liking": '0'
                }
                saveMessageToDB(current_msg_obj);

            var xhr = Ti.Network.createHTTPClient();
            xhr.addEventListener(Ti.HTTP_DONE, function(){
                //alert('done');
                console.log("TI XHR DONE!");
                console.log(this.responseText);
                groupuploadPhoto(this.responseText, message_client_id);
                //text.innerHTML += "\n" + this.responseText;
            });
            xhr.addEventListener(Ti.HTTP_STATE_CHANGED, function(){
                //alert('changed');
                console.log("STATE CHANGED");
                console.log(this.responseText);
                //text.innerHTML += "\n" + this.responseText;
            });
            
            xhr.open('POST', $.apiUrl + "/ccc/desktp_file_upload");
            xhr.setRequestHeader("contentType", "multipart/form-data");
            xhr.send({uploadedfile: content,file: file});
}
//Video capture
function groupcaptureVideo() {
        // Launch device video recording application, 
        // allowing user to capture up to 1 video clips
        navigator.device.capture.captureVideo(groupcaptureSuccess, groupcaptureError, {limit: 1});
}

//Audio capture
function groupcaptureAudio() {
        // Launch device audio recording application, 
    // allowing user to capture up to 1 audio clips
    //navigator.device.capture.captureAudio(groupcaptureaudioSuccess, groupcaptureaudioError, {limit: 1});
    var options = {
                title : "Select audio file...",
                types : window.soundtypes,
                typesDescription : "Sound clips",
                path : "/"
            };

    var curwin = Ti.UI.currentWindow; 
    curwin.openFileChooserDialog( function(fileResponse) { 
        var file = Ti.Filesystem.getFile(fileResponse[0]); 
        desktopgroupUploadAudio(file);
    },options);
    hideOptionsGroup();
}

var desktopgroupUploadAudio = function(file){
            console.log("FILE");
            console.log(file);
            
            var uploadStream = Ti.Filesystem.getFileStream(file);
        
            uploadStream.open(Ti.Filesystem.MODE_READ);
            content = uploadStream.read();
            uploadStream.close();
        
            console.log("CONTENT");
            console.log(content);
            var sender_id = $('#sendGroupMessageButton').attr('data-sender-id');
            var message_client_id = (sender_id+'_'+($.now()));
            local_file = "file:///" + file.toString();
            $('#groupMsgReader').append( // sender append chat message
                '<div  class="fRight mLeft8 chatRight" id="'+ message_client_id +'"><span class="chatRightArrow"><img src="img/chat-right.gif" alt="" /></span><img class="attachment-image-message positioncenter"  onclick="openAudio('+ "'" + local_file + "'" +')"  style="width: 32px; height: 32px;" src="img/audio-icon.gif" /><p class="date"><span><img src="img/schedule-clock.png" width="9"/></span></p></div><div class="clear"></div>'
            );
            // 
            // hide group chat options
            hideOptionsGroup();
            // scroll top slowly
            $('#groupMsgReader').animate({ scrollTop: $('#groupMsgReader').get(0).scrollHeight }, 1500);

            // save locally
            var channel_name = $('#sendGroupMessageButton').attr('data-channel-name');  
            var chat_type =   $('#sendGroupMessageButton').attr('data-chat-type'); 
            var group_id = "undefined";
            var role_id = "undefined";
            if(chat_type.toString() == "group"){
                group_id = parseInt(channel_name);
            }else{
                role_id = parseInt(channel_name);    
            }
            current_msg_obj = {
                        "sender": {
                            "id": sender_id,
                            "name": '',
                            "photo": ''
                        },
                        "receiver": {
                            "id": '',
                            "name": '',
                            "photo": ''
                        },
                        "message_id": $.now(),
                        "channel_name": channel_name,
                        "message": '',
                        "date": '',
                        "message_client_id": message_client_id,
                        "time": '',
                        "merge_to_last_message": 'false',
                        "textformat": '',
                        "attachment_type": 'audio',
                        "attachment_url": local_file,
                        "channel_event": "message",
                        "video_image": '',
                        "allowed_suborg_ids": '',
                        "group": {
                            "id": group_id,
                            "name": ''
                        },
                        "role": {
                            "id": role_id,
                            "name": ''
                        },
                        "like_count": '0',
                        "like_status": '0',
                        "is_liking": '0'
            }
            saveMessageToDB(current_msg_obj);

            var xhr = Ti.Network.createHTTPClient();
            xhr.addEventListener(Ti.HTTP_DONE, function(){
                //alert('done');
                console.log("TI XHR DONE!");
                console.log(this.responseText);
                groupuploadAudio(this.responseText, message_client_id);
                //text.innerHTML += "\n" + this.responseText;
            });
            xhr.addEventListener(Ti.HTTP_STATE_CHANGED, function(){
                //alert('changed');
                console.log("STATE CHANGED");
                console.log(this.responseText);
                //text.innerHTML += "\n" + this.responseText;
            });
            
            xhr.open('POST', $.apiUrl + "/ccc/desktp_file_upload");
            xhr.setRequestHeader("contentType", "multipart/form-data");
            xhr.send({uploadedfile: content,file: file});
}
// A button will call this function
//
function groupgetVideo() {
        //get video from library
        /*navigator.camera.getPicture(groupongallaryVideoURISuccess, onFail, 
        { 
            quality: 50, 
            destinationType: navigator.camera.DestinationType.FILE_URL,
            sourceType: navigator.camera.PictureSourceType.PHOTOLIBRARY,
            mediaType: navigator.camera.MediaType.VIDEO 
        }
    );*/
     var options = {
                title : "Select video file...",
                types : window.videotypes,
                typesDescription : "Video files",
                path : "/"
            };

            var curwin = Ti.UI.currentWindow; 
            curwin.openFileChooserDialog( function(fileResponse) { 
                var file = Ti.Filesystem.getFile(fileResponse[0]); 
                desktopgroupUploadVideo(file);
            },options);
            hideOptionsGroup(); 
}

var desktopgroupUploadVideo = function(file){
            console.log("FILE");
            console.log(file);
            
            var uploadStream = Ti.Filesystem.getFileStream(file);
        
            uploadStream.open(Ti.Filesystem.MODE_READ);
            content = uploadStream.read();
            uploadStream.close();
        
            console.log("CONTENT");
            console.log(content);
            var sender_id = $('#sendGroupMessageButton').attr('data-sender-id');
            var message_client_id = (sender_id+'_'+($.now()));
            local_file = "file:///" + file.toString();
            $('#groupMsgReader').append( // sender append chat message
                '<div  class="fRight mLeft8 chatRight" id="'+ message_client_id +'"><span class="chatRightArrow"><img src="img/chat-right.gif" alt="" /></span><img src="img/play.png" onclick="openVideo('+ "'" + local_file + "'" +')" width="30" style="position:absolute;left: 42px;top:26px;"/><img class="attachment-image-message" onclick="openVideo('+ "'" + local_file + "'" +')"  style="height:65px;width: 100px" width="100" height="65" src="img/video-icon.png" /><p class="date"><span><img src="img/schedule-clock.png" width="9"/></span></p></div><div class="clear"></div>'
            );
            // 
            // hide group chat options
            hideOptionsGroup();
            // scroll top slowly
            $('#groupMsgReader').animate({ scrollTop: $('#groupMsgReader').get(0).scrollHeight }, 1500);

            // save locally
            var channel_name = $('#sendGroupMessageButton').attr('data-channel-name');  
            var chat_type =   $('#sendGroupMessageButton').attr('data-chat-type'); 
            var group_id = "undefined";
            var role_id = "undefined";
            if(chat_type.toString() == "group"){
                group_id = parseInt(channel_name);
            }else{
                role_id = parseInt(channel_name);    
            }
            current_msg_obj = {
                        "sender": {
                            "id": sender_id,
                            "name": '',
                            "photo": ''
                        },
                        "receiver": {
                            "id": '',
                            "name": '',
                            "photo": ''
                        },
                        "message_id": $.now(),
                        "channel_name": channel_name,
                        "message": '',
                        "date": '',
                        "message_client_id": message_client_id,
                        "time": '',
                        "merge_to_last_message": 'false',
                        "textformat": '',
                        "attachment_type": 'video',
                        "attachment_url": local_file,
                        "channel_event": "message",
                        "video_image": 'img/video-icon.png',
                        "allowed_suborg_ids": '',
                        "group": {
                            "id": group_id,
                            "name": ''
                        },
                        "role": {
                            "id": role_id,
                            "name": ''
                        },
                        "like_count": '0',
                        "like_status": '0',
                        "is_liking": '0'
            }
            saveMessageToDB(current_msg_obj);

            var xhr = Ti.Network.createHTTPClient();
            xhr.addEventListener(Ti.HTTP_DONE, function(){
                //alert('done');
                console.log("TI XHR DONE!");
                console.log(this.responseText);
                groupuploadVideo(this.responseText, message_client_id);
                //text.innerHTML += "\n" + this.responseText;
            });
            xhr.addEventListener(Ti.HTTP_STATE_CHANGED, function(){
                //alert('changed');
                console.log("STATE CHANGED");
                console.log(this.responseText);
                //text.innerHTML += "\n" + this.responseText;
            });
            
            xhr.open('POST', $.apiUrl + "/ccc/desktp_file_upload");
            xhr.setRequestHeader("contentType", "multipart/form-data");
            xhr.send({uploadedfile: content,file: file});
}

function groupgetFile() {
        //get video from library
        /*navigator.camera.getPicture(groupongallaryFileURISuccess, onFail, 
        { 
            quality: 50, 
            destinationType: navigator.camera.DestinationType.FILE_URL,
            sourceType: navigator.camera.PictureSourceType.PHOTOLIBRARY,
            mediaType: navigator.camera.MediaType.ALLMEDIA 
        }
    );*/
    var options = {
                title : "Select  file...",
                types : window.filetypes,
                typesDescription : "Files ",
                path : "/"
            };

    var curwin = Ti.UI.currentWindow; 
    curwin.openFileChooserDialog( function(fileResponse) { 
        var file = Ti.Filesystem.getFile(fileResponse[0]); 
        desktopgroupUploadFile(file);
    },options);
    hideOptionsGroup();
}

var desktopgroupUploadFile = function(file){
            console.log("FILE");
            console.log(file);
            
            var uploadStream = Ti.Filesystem.getFileStream(file);
        
            uploadStream.open(Ti.Filesystem.MODE_READ);
            content = uploadStream.read();
            uploadStream.close();
        
            console.log("CONTENT");
            console.log(content);
            var sender_id = $('#sendGroupMessageButton').attr('data-sender-id');
            var message_client_id = (sender_id+'_'+($.now()));
            local_file = "file:///" + file.toString();
            $('#groupMsgReader').append( // sender append chat message
                '<div class="fRight mLeft8 chatRight" id="'+ message_client_id +'"><span class="chatRightArrow"><img src="img/chat-right.gif" alt="" /></span><img onclick="openremoteFile('+ "'" + local_file + "'" +')" class="attachment-image-message positioncenter" style="height:32px;width: 32px" width="32" height="32" src="img/file-icon.png" /><p class="date"><span><img src="img/schedule-clock.png" width="9"/></span></p></div><div class="clear"></div>'
            );
            // 
            // hide group chat options
            hideOptionsGroup();
            // scroll top slowly
            $('#groupMsgReader').animate({ scrollTop: $('#groupMsgReader').get(0).scrollHeight }, 1500);



            // save locally
            var channel_name = $('#sendGroupMessageButton').attr('data-channel-name');  
            var chat_type =   $('#sendGroupMessageButton').attr('data-chat-type'); 
            var group_id = "undefined";
            var role_id = "undefined";
            if(chat_type.toString() == "group"){
                group_id = parseInt(channel_name);
            }else{
                role_id = parseInt(channel_name);    
            }
            current_msg_obj = {
                        "sender": {
                            "id": sender_id,
                            "name": '',
                            "photo": ''
                        },
                        "receiver": {
                            "id": '',
                            "name": '',
                            "photo": ''
                        },
                        "message_id": $.now(),
                        "channel_name": channel_name,
                        "message": '',
                        "date": '',
                        "message_client_id": message_client_id,
                        "time": '',
                        "merge_to_last_message": 'false',
                        "textformat": '',
                        "attachment_type": 'file',
                        "attachment_url": local_file,
                        "channel_event": "message",
                        "video_image": '',
                        "allowed_suborg_ids": '',
                        "group": {
                            "id": group_id,
                            "name": ''
                        },
                        "role": {
                            "id": role_id,
                            "name": ''
                        },
                        "like_count": '0',
                        "like_status": '0',
                        "is_liking": '0'
            }
            saveMessageToDB(current_msg_obj);
            var xhr = Ti.Network.createHTTPClient();
            xhr.addEventListener(Ti.HTTP_DONE, function(){
                //alert('done');
                console.log("TI XHR DONE!");
                console.log(this.responseText);
                groupuploadFile(this.responseText, message_client_id);
                //text.innerHTML += "\n" + this.responseText;
            });
            xhr.addEventListener(Ti.HTTP_STATE_CHANGED, function(){
                //alert('changed');
                console.log("STATE CHANGED");
                console.log(this.responseText);
                //text.innerHTML += "\n" + this.responseText;
            });
            
            xhr.open('POST', $.apiUrl + "/ccc/desktp_file_upload");
            xhr.setRequestHeader("contentType", "multipart/form-data");
            xhr.send({uploadedfile: content,file: file});
}