$(document).ready(function(){	
    $(document).on('click','.grpDetails',function (e) {
        ;
        e.stopPropagation();
        e.preventDefault();
        var group_id = $(this).siblings('.custom-group').attr('data-group-id')
        var group_creator_id = $(this).siblings('.custom-group').attr('data-group-creator-id')
        window.group_id = group_id
        window.group_creator_id = group_creator_id
        $.ajax({
            url: $.apiUrl + "/ccc/api_v1/groups/"+ group_id+ "/users",
            type: "GET",
            beforeSend: function(xhr) {
                xhr.setRequestHeader('token', localStorage["session_token"]);
                $.mobile.loading('show');
            },
            complete: function(jqXHR, textStatus) { $.mobile.loading('hide'); },
            success: function(json){
                console.log(json.userinfo)
                var source   = $("#group-details-template").html();
                var template = Handlebars.compile(source);
                var context = json.userinfo
				var current_user_id = JSON.parse(localStorage.userinfo).user_info.user_id
                $("#listGroupDetails").html(template(context));
                console.log(json.groupinfo.group_name)
                window.group_name = json.groupinfo.group_name
                window.group_photo = json.groupinfo.group_photo
                window.group_total_members = json.userinfo.length
                if(window.group_creator_id == JSON.parse(localStorage.userinfo).user_info.user_id){
                    $('#group_edit').show();
                    $('#group_member_edit').show();
                    $('#group_delete').show();
                    $('.grp_details_head_bg').find('img').first().attr('id','grp_pic');
                }else{
                    $('#group_edit').hide();
                    $('#group_member_edit').hide();
                    $('#group_delete').hide();
                    $('.grp_details_head_bg').find('img').first().attr('id','disabled_grp_pic');
                }
                if(window.group_photo == null || window.group_photo == ""){
                    $('.grp_details_head_bg').find('img').first().attr('src','img/group_placeholder.png');
                }else{
                    $('.grp_details_head_bg').find('img').first().attr('src',window.group_photo);    
                }
                $.mobile.changePage('#group-details-page',{changeHash: false}); 
				
				// 
				// clicking on user list should open message box
				$("#listGroupDetails .message-btn").on('click', function(e){
					var user_id = $(this).attr('data-user-id');
					$(".message-btn[data-current-user-id='"+current_user_id+"'][data-user-id='"+user_id+"']").trigger('click');
				});
				
				// 
				// this will show the online status
	            var pubnub = PUBNUB.init({
	                publish_key: $.pubnubkeys.publish_key,
	                subscribe_key: $.pubnubkeys.subscribe_key,
	                uuid: current_user_id
	            });
	            pubnub.subscribe({
	                channel: localStorage["org_channel"],
	                message: function (m) {},
	                presence: function (message, env, channel) {
                        var OnlineStatusIcon = $('.' + message.uuid + '_online_status_icon');
                        var OfflineStatusIcon = $('.' + message.uuid + '_offline_status_icon');
                        if (message.action == "join") {
                            OfflineStatusIcon.hide();
                            OnlineStatusIcon.show();
                        } else {
                            OnlineStatusIcon.hide();
                            OfflineStatusIcon.show();
                        }
	                }
	            });
				
				// 
				// adjust geight by JS
                $('#listGroupDetails').css('height',($(window).height() - (143 + $('.headerPan').height() + $('.ui-footer').height())).toString() + "px");                           
            },
            error: function (xhr, ajaxOptions, thrownError) {
                console.log(xhr);
                console.log(thrownError);
            }           
        });           
    });
    // Group,role details API call from group,role chat
    $(document).on('click','.grpDetfromGrpchat',function (e) {
        e.stopPropagation();
        e.preventDefault();
        var group_id = $(this).attr('data-group-id')
        var group_type = $(this).attr('data-group-type')
        window.group_id = group_id
        if(group_type == 'group') {
            $.ajax({
                url: $.apiUrl + "/ccc/api_v1/groups/"+ group_id+ "/users",
                type: "GET",
                beforeSend: function(xhr) {
                    xhr.setRequestHeader('token', localStorage["session_token"]);
                    $.mobile.loading('show');
                },
                complete: function(jqXHR, textStatus) { $.mobile.loading('hide'); },
                success: function(json){
                    console.log(json.userinfo)
                    var source   = $("#group-details-template").html();
                    var template = Handlebars.compile(source);
                    var context = json.userinfo
					var current_user_id = JSON.parse(localStorage.userinfo).user_info.user_id
                    $("#listGroupDetails").html(template(context));
                    console.log(json.groupinfo.group_name)
                    window.group_name = json.groupinfo.group_name
                    window.group_photo = json.groupinfo.group_photo
                    window.group_total_members = json.userinfo.length

                    if(window.group_creator_id == JSON.parse(localStorage.userinfo).user_info.user_id){
                            $('#group_edit').show();
                            $('#group_member_edit').show();
                            $('#group_delete').show();
                            $('.grp_details_head_bg').find('img').first().attr('id','grp_pic')
                    }else{
                            $('#group_edit').hide();
                            $('#group_member_edit').hide();
                            $('#group_delete').hide();
                            $('.grp_details_head_bg').find('img').first().attr('id','disabled_grp_pic')
                    }
                    
                    if(window.group_photo == null || window.group_photo == ""){
                            $('.grp_details_head_bg').find('img').first().attr('src','img/group_placeholder.png');
                    }else{
                            $('.grp_details_head_bg').find('img').first().attr('src',window.group_photo);    
                    }

                    $.mobile.changePage('#group-details-page',{changeHash: false}); 
                    
					// 
					// clicking on user list should open message box
					$("#listGroupDetails .message-btn").on('click', function(e){
						var user_id = $(this).attr('data-user-id');
						$(".message-btn[data-current-user-id='"+current_user_id+"'][data-user-id='"+user_id+"']").trigger('click');
					});
				
					// 
					// this will show the online status
		            var pubnub = PUBNUB.init({
		                publish_key: $.pubnubkeys.publish_key,
		                subscribe_key: $.pubnubkeys.subscribe_key,
		                uuid: current_user_id
		            });
		            pubnub.subscribe({
		                channel: localStorage["org_channel"],
		                message: function (m) {},
		                presence: function (message, env, channel) {
                            var OnlineStatusIcon = $('.' + message.uuid + '_online_status_icon');
                            var OfflineStatusIcon = $('.' + message.uuid + '_offline_status_icon');
                            if (message.action == "join") {
                                OfflineStatusIcon.hide();
                                OnlineStatusIcon.show();
                            } else {
                                OnlineStatusIcon.hide();
                                OfflineStatusIcon.show();
                            }
		                }
		            });
					
					// 
					// adjust height by JS
                    $('#listGroupDetails').css('height',($(window).height() - (143 + $('.headerPan').height() + $('.ui-footer').height())).toString() + "px");                           
                },
                error: function (xhr, ajaxOptions, thrownError) {
                    console.log(xhr);
                    console.log(thrownError);
                }           
            });              
        }
        else {
            var role_id = group_id
            $.ajax({
                url: $.apiUrl + "/ccc/api_v1/roles/"+ role_id+ "/users",
                type: "GET",
                beforeSend: function(xhr) {
                    xhr.setRequestHeader('token', localStorage["session_token"]);
                    $.mobile.loading('show');
                },
                complete: function(jqXHR, textStatus) { $.mobile.loading('hide'); },
                success: function(json){
                    console.log(json.userinfo)
                    var source   = $("#role-details-template").html();
                    var template = Handlebars.compile(source);
                    var context = json.userinfo
                    $("#listRoleDetails").html(template(context));
                    console.log(json.role_info.role_name)
                    window.role_name = json.role_info.role_name
                    window.role_photo = json.role_info.role_photo
                    window.role_total_members = json.userinfo.length
                    $.mobile.changePage('#role-details-page',{changeHash: false}); 
                    $('#listRoleDetails').css('height',($(window).height() - (143 + $('.headerPan').height() + $('.ui-footer').height())).toString() + "px");                           
                },
                error: function (xhr, ajaxOptions, thrownError) {
                    console.log(xhr);
                    console.log(thrownError);
                }           
            });
        }         
    });    
    // end of Group,role details API call from group,role chat
    $('#group-details-page').on('pageshow', function(event, ui) { //change the name of the group dynamically
        $('#group-details-page').find('#grp_name').text(window.group_name)
        if (window.group_photo != null && window.group_photo != '') {
            $('#group-details-page').find('#grp_pic').attr('src',window.group_photo)    
        }
        else {
            $('#group-details-page').find('#grp_pic').attr('src','img/group_placeholder.png')
        }
        $('#group-details-page').find('#grp_member_number').text('Total Members: '+window.group_total_members)
    }); 

    $(document).on('click','#backtogrp',function(){
        $.mobile.changePage('#groups');
    });

    // Role details API is being called here
    $(document).on('click','.roleDetails',function (e) {
        ;
        e.stopPropagation();
        e.preventDefault();
        var role_id = $(this).siblings('.custom_role').attr('data-group-id')
        $.ajax({
            url: $.apiUrl + "/ccc/api_v1/roles/"+ role_id+ "/users",
            type: "GET",
            beforeSend: function(xhr) {
                xhr.setRequestHeader('token', localStorage["session_token"]);
                $.mobile.loading('show');
            },
            complete: function(jqXHR, textStatus) { $.mobile.loading('hide'); },
            success: function(json){
                console.log(json.userinfo)
                var source   = $("#role-details-template").html();
                var template = Handlebars.compile(source);
                var context = json.userinfo
                $("#listRoleDetails").html(template(context));
                console.log(json.role_info.role_name)
                window.role_name = json.role_info.role_name
                window.role_photo = json.role_info.role_photo
                window.role_total_members = json.userinfo.length
                $.mobile.changePage('#role-details-page'); 
                $('#listRoleDetails').css('height',($(window).height() - (143 + $('.headerPan').height() + $('.ui-footer').height())).toString() + "px");                           
            },
            error: function (xhr, ajaxOptions, thrownError) {
                console.log(xhr);
                console.log(thrownError);
            }           
        });           
    });    
    $('#role-details-page').on('pageshow', function(event, ui) { //change the name of the group dynamically
        $('#role-details-page').find('#grp_name').text(window.role_name)
        if (window.role_photo != null && window.role_photo != '') {
            $('#role-details-page').find('#grp_pic_role').attr('src',window.role_photo)    
        }
        else {
            $('#role-details-page').find('#grp_pic_role').attr('src','img/group_placeholder.png')
        }
        $('#role-details-page').find('#grp_member_number').text('Total Members: '+window.role_total_members)
    }); 
    // End of role details api call


	$(document).on('click','.groupLeaveButton',function (e) {
		e.stopPropagation();
		e.preventDefault();
	    showGroupLeaveAlert();	
 
	});


    $(document).on('click','#group_edit',function(e){
        ;
        e.stopPropagation();
        e.preventDefault();
        $.mobile.changePage('#edit-group-details-page',{changeHash: false}); 
        
        $('#edit-custom-group-subject-input').val(window.group_name);
    });

    $(document).on('click','#grp_pic',function(){

        /*navigator.notification.confirm(
            'Choose picture source!', // message
            onConfirm,                // callback to invoke with index of button pressed
            'Choose Picture!',              // title
            ['Camera','Library']      // buttonLabels
        );*/
        var options = {
            title: "Select image file...",
            types: window.imagetypes,
            typesDescription: "Image files",
            path: "/"
        };

        var curwin = Ti.UI.currentWindow;
        curwin.openFileChooserDialog(function (fileResponse) {
            var file = Ti.Filesystem.getFile(fileResponse[0]);
            desktopUploadGroupEdit(file);
        }, options);
    });

    var desktopUploadGroupEdit = function (file) {
        console.log("FILE");
        console.log(file);
        $.mobile.loading('show');
        var uploadStream = Ti.Filesystem.getFileStream(file);

        uploadStream.open(Ti.Filesystem.MODE_READ);
        content = uploadStream.read();
        uploadStream.close();

        console.log("CONTENT");

        var xhr = Ti.Network.createHTTPClient();
        xhr.addEventListener(Ti.HTTP_DONE, function () {
            //alert('done');
            console.log("TI XHR DONE!");
            console.log(this.responseText);
            //uploadUserPhoto(this.responseText);
            image_url = this.responseText;
            $.ajax({
                url: $.apiUrl + "/ccc/api_v1/editgroup/" + window.group_id,
                type: "POST",
                data: {
                    group_image: image_url
                },
                beforeSend: function (xhr) {
                    xhr.setRequestHeader('token', localStorage["session_token"]);
                },
                success: function (json) {
                    $.ajax({
                        url: $.apiUrl + '/index.php/ccc/api_v1/contacts',
                        beforeSend: function (xhr) {
                            xhr.setRequestHeader('token', localStorage["session_token"]);
                        },
                        success: function (json) {
                            localStorage.hris_enterprise_chat_groups = JSON.stringify(json.groups);
                            window.group_photo = ($.apiUrl + "/" + image_url);
                            $('.grp_details_head_bg').find('img').first().attr('src', $.apiUrl + "/" + image_url);
                            $('#groupListView').find('.divRows').each(function () {
                                if ($(this).find('.custom-group').attr('data-group-id') == window.group_id) {
                                    $(this).find('.grpDetails').find('img').attr('src', $.apiUrl + "/" + image_url);
                                }
                            });
                            $.mobile.loading('hide');
                        }
                    });
                },
                error: function (xhr, ajaxOptions, thrownError) {
                    console.log(xhr);
                    console.log(thrownError);
                }
            });
            //text.innerHTML += "\n" + this.responseText;
        });
        xhr.addEventListener(Ti.HTTP_STATE_CHANGED, function () {
            //alert('changed');
            console.log("STATE CHANGED");
            console.log(this.responseText);
            //text.innerHTML += "\n" + this.responseText;
        });

        xhr.open('POST', $.apiUrl + "/ccc/desktp_file_upload");
        xhr.setRequestHeader("contentType", "multipart/form-data");
        xhr.send({
            uploadedfile: content,
            file: file
        });
    }

    function onConfirm(buttonIndex) {
        var source;
        if (buttonIndex.toString() == "1") {
            source = navigator.camera.PictureSourceType.CAMERA
        } else if(buttonIndex.toString() == "2"){
            source = navigator.camera.PictureSourceType.PHOTOLIBRARY
        }else{
            return false;
        }
        navigator.camera.getPicture(uploadgroupPhotoURISuccess, function (message) {
           return false;
        }, {
            quality: 50,
            destinationType: navigator.camera.DestinationType.FILE_URI,
            sourceType: source
        });
    }


    // Called when a photo is successfully retrieved
//
function uploadgroupPhotoURISuccess(imageURI) {
    // Upload the image to server using FileTransfer
    // 
    $.mobile.loading('show');
    var options = new FileUploadOptions();
    options.fileKey     = "file";
    options.fileName    = imageURI.substr(imageURI.lastIndexOf('/')+1);
    options.mimeType    = "image/jpeg";
    options.headers = {
        Connection: "close"
    }
    options.chunkedMode = false;
    var ft = new FileTransfer();
    ft.upload(
        imageURI, 
        encodeURI($.apiUrl + "/ccc/file_upload"), 
        function(r) {
            var image_url = r.response.replace(/[\n]/g, "");

                $.ajax({
                url: $.apiUrl + "/ccc/api_v1/editgroup/"+ window.group_id,
                type: "POST",
                data: { group_image: image_url },
                beforeSend: function(xhr) {
                    xhr.setRequestHeader('token', localStorage["session_token"]);
                },
                success: function(json){
                    $.ajax({
                        url: $.apiUrl + '/index.php/ccc/api_v1/contacts',
                        beforeSend: function (xhr) {
                            xhr.setRequestHeader('token', localStorage["session_token"]);
                        },
                        success: function (json) {
                            localStorage.hris_enterprise_chat_groups = JSON.stringify(json.groups);              
                            /*navigator.notification.alert(
                                "Group image successfully updated",  // message
                                null,               // callback
                                "Success!",         // title
                                "Ok"                // buttonName
                            );*/
                            window.group_photo = ($.apiUrl + "/" + image_url);
                            $('.grp_details_head_bg').find('img').first().attr('src',$.apiUrl + "/" + image_url);
                            $('#groupListView').find('.divRows').each(function(){
                                if($(this).find('.custom-group').attr('data-group-id') == window.group_id){
                                    $(this).find('.grpDetails').find('img').attr('src',$.apiUrl + "/" + image_url);
                                }
                            });
                            $.mobile.loading('hide');
                        }
                    });
                },
                error: function (xhr, ajaxOptions, thrownError) {
                    console.log(xhr);
                    console.log(thrownError);
                }           
            });

        },
        function(error) {
            // alert("An error has occurred: Code = " + error.code);
            // console.log("upload error source " + error.source);
            // console.log("upload error target " + error.target);
            alert("An error has occurred");
        }, 
        options
    );

}
    
    $(document).on('click','#group_member_edit',function(e){
                        // ;
                        e.stopPropagation();
                        e.preventDefault();
                        $.mobile.loading('show');
                        $.ajax({
                            url: $.apiUrl + "/ccc/api_v1/groups/"+ window.group_id + "/users",
                            type: "GET",
                            beforeSend: function(xhr) {
                                    xhr.setRequestHeader('token', localStorage["session_token"]);
                            },
                            success: function(json){             
                                data = json.userinfo;
                                $('#editlastgroupNameInline').text(window.group_name);
                                $.mobile.changePage('#custom-group-edit-step2',{changeHash: false});
                                for(var i = 0 ;i<data.length;i++){
                                    $('#editGroupContactListView .group-user-row').each(function(){
                                        if($(this).attr('data-user-id') == data[i].personal_info.user_id){
                                            console.log($(this).find('.user-select-checkbox'));
                                           $(this).find('.user-select-checkbox').prop('checked',true);
                                           $(this).find('img.mTop12').attr('src',"img/checked.png");
                                           console.log($(this).find('img.mTop12'));
                                        }
                                    });
                                } 
                                $.mobile.loading('hide');
								// hack fix for OSX desktop
								$('#editGroupContactListView').scroll(function(){
									$('.ui-page').trigger('click');
								});
                            }
                        });
    });

    $(document).on('click','#edit-custom-group-step1-next',function(e){
        e.stopPropagation();
        e.preventDefault();
        $.mobile.loading('show');
        var group_name = $('#edit-custom-group-subject-input').val();
        $.ajax({
            url: $.apiUrl + "/ccc/api_v1/editgroup/"+ window.group_id,
            type: "POST",
            data: { group_name: group_name },
            beforeSend: function(xhr) {
                xhr.setRequestHeader('token', localStorage["session_token"]);
            },
            success: function(json){
                $.ajax({
                    url: $.apiUrl + '/index.php/ccc/api_v1/contacts',
                    beforeSend: function (xhr) {
                        xhr.setRequestHeader('token', localStorage["session_token"]);
                    },
                    success: function (json) {
                        localStorage.hris_enterprise_chat_groups = JSON.stringify(json.groups);     
                        $('#groupListView').find('.divRows').each(function(){
                            if($(this).find('.custom-group').attr('data-group-id') == window.group_id){
                                $(this).find('.custom-group').find('.mainChatName').text(group_name);
                            }
                        });
                        window.group_name = group_name;
                        $.mobile.changePage('#group-details-page',{changeHash: false}); 
                        $('#group-details-page').find('#grp_name').text(group_name);
                        $.mobile.loading('hide');
                    }
                });
            },
            error: function (xhr, ajaxOptions, thrownError) {
                console.log(xhr);
                console.log(thrownError);
            }           
        });

    });
    // Handlebars helper        
});

function showGroupLeaveAlert() {
    if(JSON.parse(localStorage.userinfo).user_info.user_id == window.group_creator_id){
         /*navigator.notification.confirm(
            'If you leave this group you need to assign a member as admin of this group! Continue?',  
             deleteadmingroup,         
            'You are about to leave this group',            
            ['Yes','No']                   
        ); */
        if(confirm("If you leave this group you need to assign a member as admin of this group! Continue?")){
            deleteadmingroup();
        }   
    }else{
        /*navigator.notification.confirm(
            'Continue?',  
             deletegroup,         
            'You are about to leave this group',            
            ['Yes','No']                   
        );*/
        if(confirm("Continue?")){
            deletegroup();
        }     
    }
}

function deleteadmingroup(){
        $.ajax({
                url: $.apiUrl + "/ccc/api_v1/groups/"+ window.group_id+ "/users",
                type: "GET",
                beforeSend: function(xhr) {
                    xhr.setRequestHeader('token', localStorage["session_token"]);
                    $.mobile.loading('show');
                },
                complete: function(jqXHR, textStatus) { $.mobile.loading('hide'); },
                success: function(json){
                    var source   = $("#assign-admin-group-template").html();
                    var template = Handlebars.compile(source);    
                    var users = json.userinfo
                    //var lists = jQuery.parseJSON(localStorage["hris_enterprise_chat_contacts"]);
                    var html = template(users);
                    $('#assignAdminGroupContacts').html(html); 
                    $('#assignAdminGroupListView').height((parseInt($(window).height()) - 120) + "px"); 
                    var grname = $('div[data-group-id="'+window.group_id+'"]').closest('.divRows').find(".mainChatName").text();
                    $('#assignAdminGroupInline').text(grname);
                    $('#assignAdminGroupListView .divRows').each(function(){
                        if($(this).find('.user-detail-btn').attr('data-user-id') == window.group_creator_id){
                           $(this).remove(); 
                        }
                    });
                    $.mobile.changePage('#assign-admin-group',{changeHash: false});
					// hackfix for OSX desktop scroll
					$('#assignAdminGroupListView').scroll(function(){
						$('.ui-page').trigger('click');
					});
                }
       });
   
}

$( document ).on('click','#assign-admin',function(){
        var selected_user_id;
        $("input[name*=admin_choose_radio]:checked").each(function () {
            selected_user_id = $(this).attr('data-user-id');
        });
        if(selected_user_id == "" || selected_user_id == null){
            //navigator.notification.alert("Please choose an admin", null, window.group_name, "OK");
            alert("Please choose an admin");
            return false;
        }

        $.ajax({
            url: $.apiUrl + "/ccc/api_v1/group/"+ window.group_id + "/remove",
            type: "POST",
            data: {"user_id": selected_user_id},
            beforeSend: function(xhr) {
                xhr.setRequestHeader('token', localStorage["session_token"]);
            },
            success: function(json){
                window.group_creator_id = selected_user_id;
                $.ajax({
                    url: $.apiUrl + '/index.php/ccc/api_v1/contacts',
                    beforeSend: function (xhr) {
                        xhr.setRequestHeader('token', localStorage["session_token"]);
                    },
                    success: function (json) {
                        localStorage.hris_enterprise_chat_groups    = JSON.stringify(json.groups);              
                    }
                }); 
                $.mobile.changePage('#groups',{changeHash: false});  
                var grname = $('div[data-group-id="'+window.group_id+'"]').closest('.divRows').find(".mainChatName").text();        
                $('div[data-group-id="'+window.group_id+'"]').closest('.divRows').remove();
                /*navigator.notification.alert(
                    "You have successfully left from "+ grname,  // message
                    null,               // callback
                    "Success!",         // title
                    "Ok"                // buttonName
                );*/
                alert("You have successfully left from "+ grname)
            },
            error: function (xhr, ajaxOptions, thrownError) {
                console.log(xhr);
                console.log(thrownError);
            }           
        });
});


function deletegroup() {
    	// var group_id = $('#groupLeaveButton').siblings('#groupNameInline').attr('data-group-id');
        $.ajax({
            url: $.apiUrl + "/ccc/api_v1/group/"+ window.group_id +"/remove",
            type: "POST",
            beforeSend: function(xhr) {
            	xhr.setRequestHeader('token', localStorage["session_token"]);
            },
            success: function(json){
    			$.ajax({
    				url: $.apiUrl + '/index.php/ccc/api_v1/contacts',
    				beforeSend: function (xhr) {
    					xhr.setRequestHeader('token', localStorage["session_token"]);
    				},
    				success: function (json) {
    					localStorage.hris_enterprise_chat_groups 	= JSON.stringify(json.groups);				
    				}
    		    });	
    		 	$.mobile.changePage('#groups',{changeHash: false});  
                var grname = $('div[data-group-id="'+window.group_id+'"]').closest('.divRows').find(".mainChatName").text();      	
                $('div[data-group-id="'+window.group_id+'"]').closest('.divRows').remove();
                /*navigator.notification.alert(
                    "You have successfully left from "+ grname,  // message
                    null,               // callback
                    "Success!",         // title
                    "Ok"                // buttonName
                );*/
                alert("You have successfully left from "+ grname);
            },
            error: function (xhr, ajaxOptions, thrownError) {
                console.log(xhr);
                console.log(thrownError);
            }	        
        });    
}		


// 
// Delete custom group

function showDeleteGroupAlert(group_id) {
    var grname = $('div[data-group-id="'+ group_id +'"]').closest('.divRows').find(".mainChatName").text();  

    /*navigator.notification.confirm(
        'Are you sure to delete "'+ grname +'" group?',
        deleteGroup,         
        'Delete Group?',              
        ['Yes','No']                   
    );*/
    if(confirm('Are you sure to delete "'+ grname +'" group?')){
        deleteGroup("1")
    }
}

function deleteGroup(buttonIndex) {
    if(buttonIndex.toString() == "1"){
        var group_id = window.group_id;
        var grname = $('div[data-group-id="'+ group_id +'"]').closest('.divRows').find(".mainChatName").text();    

        $.ajax({
            url: $.apiUrl + "/ccc/api_v1/groups/"+ group_id +"/destroy",
            type: "DELETE",
            beforeSend: function(xhr) { 
                xhr.setRequestHeader('token', localStorage["session_token"]); 
            },
            success: function(json) {
                $.ajax({
                    url: $.apiUrl + '/index.php/ccc/api_v1/contacts',
                    beforeSend: function(xhr) { 
                        xhr.setRequestHeader('token', localStorage["session_token"]); 
                    },
                    success: function (json) { localStorage.hris_enterprise_chat_groups = JSON.stringify(json.groups); }
                }); 
                $.mobile.changePage('#groups');  
                $('div[data-group-id="'+ group_id +'"]').closest('.divRows').remove();
                //navigator.notification.alert(grname + " successfully deleted", null, "Success!", "Ok");
                alert(grname + " successfully deleted");
            },
            error: function (xhr, ajaxOptions, thrownError) {
                //navigator.notification.alert(xhr.error.text_msg, null, "Error!", "Ok");
                alert(xhr.error.text_msg)
            },
        });
    }
}
