Utility = function () {
    return {
        linkify: function (text) {
            if (text) {
                text = text.replace(
                    /((https?\:\/\/)|(www\.))(\S+)(\w{2,4})(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?/gi,
                    function(url){
                        var full_url = url;
                        if (!full_url.match('^https?:\/\/')) {
                            full_url = 'http://' + full_url;
                        }
                        return '<a href="full_url" target="_blank" data-external-url="' + full_url + '" class="external-link">' + url + '</a>';
                    }
                );
            }
            return text;
        },

        linkifyMessage: function (dom) {
            if($(dom).text().match(/((https?\:\/\/)|(www\.))(\S+)(\w{2,4})(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?/gi)){
                if($(dom).text().match(/[<>]/)){
                    
                }else{
                    $(dom).html(
                        Utility.linkify($(dom).text())
                    )
                }    
            }    
        },

        linkifyMessages: function (dom) {
            var message_doms = $(dom + ' .message');

            $.each( message_doms, function() {
                if($(this).text().match(/((https?\:\/\/)|(www\.))(\S+)(\w{2,4})(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?/gi)){
                    if($(this).text().match(/[<>]/)){
                        
                    }else{
                        $(this).html(
                            Utility.linkify($(this).text())
                        )
                    }
                }
            });
        }
    }    
}();