$().ready(function(){
	$('#signinForm').submit(function(e) {
		var email = $('#email').val();
		var password = $('#password').val();

		$.ajax({
			url: $.apiUrl + "/index.php/ccc/api_v1/session_api",
        	type: "POST",
			data: { email: email, password: password },
			beforeSend: function() { $.mobile.loading('show'); },
			complete: function(jqXHR, textStatus) { $.mobile.loading('hide'); },
			success: function(data){

				$.mobile.changePage('#AppProgressScreen');
				$('#progressStatus').show();
				$('#errorStatus').hide();

				var session_token = data.token;
				localStorage.setItem("userinfo", JSON.stringify(data));
				localStorage.setItem("session_token", session_token);
				localStorage.setItem("current_user_email", email);
				localStorage.setItem("current_user_password", password);

				$('#progressStatusText').text('Initializing...');				

				$.ajax({
					url: $.apiUrl + '/index.php/ccc/api_v1/contacts',
					beforeSend: function (xhr) {
						xhr.setRequestHeader('token', session_token);

						$('#progressStatusText').text('Initializing...');
					},
					success: function (json) {
						localStorage.hris_enterprise_chat_contacts = JSON.stringify(json.people);
						localStorage.hris_enterprise_chat_roles = JSON.stringify(json.roles);
						localStorage.hris_enterprise_chat_groups = JSON.stringify(json.groups);
						all_channels = json.channel
						var channel_object = getLastSavedMessageFromDB(all_channels)//,function(channel_object){
							$.ajax({
								url: $.apiUrl + "/ccc/api_v1/getLastmsg",
								type: "POST",
								data: { "json": JSON.stringify(channel_object)},
								beforeSend: function (xhr) {
									xhr.setRequestHeader('token', session_token);

									$('#progressStatusText').text('Initializing...');
								},
								success: function(data){
									var messages = []
									var syncdata = data.message
									try
									{
										var cleanedsyncdata = syncdata.filter(function(v){return v!=='null'});
									}
									catch(err)
									{
									  	var cleanedsyncdata = []
									  	alert('Error fetching data from API! Please try again later');
									}
									if(cleanedsyncdata.length == 0){
										window.location.replace('messenger.html');
									}
									$.each(cleanedsyncdata,function(index,m){
										if(m.toString() != "null"){
											$.each(m,function(i,m_object){
												if(m_object != null){
													messages.push(m_object) 	
												}
											});
										}	
									});
									saveLatestMessageToDB(messages);
										
								},
								error: function (data) {
									$('#progressStatus').hide();
									$('#errorStatus').show();
									$('#errorStatusText').text('Error syncing messages from server...');									
								}
							});	
						//});
					},
					error: function (json) {
						$('#progressStatus').hide();
						$('#errorStatus').show();
						$('#errorStatusText').text('Error syncing contact list from server...');
					}
			    });
			},
			error: function(xhr, ajaxOptions, thrownError){
        		$('#login-error-popup').popup();
				$('#login-error-popup').popup('open', { positionTo: '#targetHead' });          				
			}
		});
		e.preventDefault();
	});

	// 
	// check if already logged in
	// 
    var email = localStorage["current_user_email"];
    var password = localStorage["current_user_password"];
    var session_token = localStorage["session_token"];

    if ((email == null) || (password == null) || (session_token == null)) {
    	// 
    	// delay for some time and stay on the splash screen
    	// setTimeout(function(){
    		$.mobile.changePage('#loginScreen');
    	// }, 2000);
    } else {
		$.ajax({
			url: $.apiUrl + "/index.php/ccc/api_v1/session_api",
        	type: "POST",
			data: { email: email, password: password },
			success: function(data){
				$.mobile.changePage('#AppProgressScreen');
				$('#progressStatus').show();
				$('#errorStatus').hide();

				var current_session_token = data.token;
				localStorage.setItem("userinfo", JSON.stringify(data));
				localStorage.setItem("session_token", current_session_token);
	
				$('#progressStatusText').text('Initializing...');								

				$.ajax({
					url: $.apiUrl + '/index.php/ccc/api_v1/contacts',
					beforeSend: function (xhr) {
						xhr.setRequestHeader('token', current_session_token);

						$('#progressStatusText').text('Initializing...');
					},
					success: function (json) {
						localStorage.hris_enterprise_chat_contacts  = JSON.stringify(json.people);
						localStorage.hris_enterprise_chat_roles 	= JSON.stringify(json.roles);
						localStorage.hris_enterprise_chat_groups	= JSON.stringify(json.groups);
						all_channels = json.channel
						var channel_object = getLastSavedMessageFromDB(all_channels);//,function(channel_object){
							$.ajax({
								url: $.apiUrl + "/ccc/api_v1/getLastmsg",
								type: "POST",
								data: { "json": JSON.stringify(channel_object)},
								beforeSend: function (xhr) {
									xhr.setRequestHeader('token', session_token);

									$('#progressStatusText').text('Initializing...');
								},
								success: function(data){
									var messages = []
									var syncdata = data.message
									try
									{
										var cleanedsyncdata = syncdata.filter(function(v){return v!=='null'});
									}
									catch(err)
									{
									  	var cleanedsyncdata = []
									  	alert('Error fetching data from API! Please try again later');
									}
									
									if(cleanedsyncdata.length == 0){
										window.location.replace('messenger.html');
									}
									$.each(cleanedsyncdata,function(index,m){
										if(m.toString() != "null"){
											$.each(m,function(i,m_object){
												if(m_object != null){
													messages.push(m_object) 	
												}
											});
										}	
									});
									saveLatestMessageToDB(messages);
								},
								error: function (data) {
									$('#progressStatus').hide();
									$('#errorStatus').show();
									$('#errorStatusText').text('Error syncing messages from server...');									
								}
							});	
						//});
					},
					error: function (json) {
						$('#progressStatus').hide();
						$('#errorStatus').show();
						$('#errorStatusText').text('Error syncing contact list from server...');
					}
			    });
			},
			error: function(xhr, ajaxOptions, thrownError){
        		$.mobile.changePage('#loginScreen');      				
			}
		}); 
    }
    // 
	// end of login check
	// 

});